ifndef _d3d9TYPES_H_
_d3d9TYPES_H_ equ 1

ifndef DIRECT3D_VERSION
DIRECT3D_VERSION equ 0900h
endif

;// include this file content only if compiling for DX9 interfaces

;#include <float.h>


;// D3DCOLOR is equivalent to D3DFMT_A8R8G8B8
ifndef D3DCOLOR_DEFINED
D3DCOLOR typedef DWORD 
D3DCOLOR_DEFINED equ 1
endif

;// maps unsigned 8 bits/channel to D3DCOLOR
;// maps unsigned 8 bits/channel to D3DCOLOR
D3DCOLOR_ARGB MACRO a, r, g, b
	LOCAL DefineAs
	IF a GT 0ffh
		.ERR <D3DCOLOR component 'a'(=a) out of limits(over 0ffh)>
	ENDIF
	IF r GT 0ffh
		.ERR <D3DCOLOR component 'r'(=r) out of limits(over 0ffh)>
	ENDIF
	IF g GT 0ffh
		.ERR <D3DCOLOR component 'g'(=g) out of limits(over 0ffh)>
	ENDIF
	IF b GT 0ffh
		.ERR <D3DCOLOR component 'b'(=b) out of limits(over 0ffh)>
	ENDIF

	DefineAs	TEXTEQU %((((a) AND 0ffh) SHL 24) OR (((r) AND 0ffh) SHL 16) OR (((g) AND 0ffh) SHL 8) OR ((b) AND 0ffh))
	EXITM DefineAs
ENDM D3DCOLOR_ARGB

D3DCOLOR_RGBA MACRO r, g, b, a
	LOCAL DefineAs
	DefineAs TEXTEQU %(D3DCOLOR_ARGB(a, r, g, b)
	EXITM DefineAs
ENDM D3DCOLOR_RGBA


D3DCOLOR_XRGB MACRO r, g, b
	LOCAL DefineAs
	DefineAs	TEXTEQU %(D3DCOLOR_ARGB(0ffh, r, g, b))
	EXITM DefineAs
ENDM D3DCOLOR_XRGB

;// maps floating point channels (0.f to 1.f range) to D3DCOLOR
D3DCOLOR_COLORVALUE MACRO r, g, b, a
	LOCAL DefineAs
	DefinaAs TEXTEQU %(D3DCOLOR_RGBA((DWORD)((r)*255.f), (DWORD)((g)*255.f), (DWORD)((b)*255.f), (DWORD)((a)*255.f)))
	EXITM DefineAs
ENDM D3DCOLOR_COLORVALU

;#define D3DCOLOR_XYUV(y,u,v)   D3DCOLOR_ARGB(0xff,y,u,v)
;#define D3DCOLOR_AYUV(a,y,u,v) D3DCOLOR_ARGB(a,y,u,v)



IFNDEF D3DVECTOR_DEFINED
    _D3DVECTOR struct   DWORD
        x   FLOAT   ?
        y   FLOAT   ?
        z   FLOAT   ?
    _D3DVECTOR  ENDS
    D3DVECTOR		TYPEDEF		_D3DVECTOR
    LPD3DVECTOR		TYPEDEF		PTR _D3DVECTOR
    D3DVECTOR_DEFINED=1
ENDIF

    D3DCOLORVALUE struct   
        r   FLOAT   ?
        g   FLOAT   ?
        b   FLOAT   ?
        a   FLOAT   ?
    D3DCOLORVALUE  ENDS

IFNDEF D3DRECT_DEFINED
    D3DRECT struct   
        x1      LONG    ?
        y1      LONG    ?
        x2      LONG    ?
        y2      LONG    ?
    D3DRECT  ENDS
ENDIF

IFNDEF D3DMATRIX_DEFINED
    _D3DMATRIX struct   DWORD
    ;   union 
    ;   {
    ;       struct 
    ;       {
    ;           float        _11, _12, _13, _14;
    ;           float        _21, _22, _23, _24;
    ;           float        _31, _32, _33, _34;
    ;           float        _41, _42, _43, _44;
    ;       };
    ;       float m[4][4];
    ;   };
    ;    UNION
            _11		FLOAT		?
            _12		FLOAT		?
            _13		FLOAT		?
            _14		FLOAT		?
            _21		FLOAT		?
            _22		FLOAT		?
            _23		FLOAT		?
            _24		FLOAT		?
            _31		FLOAT		?
            _32		FLOAT		?
            _33		FLOAT		?
            _34		FLOAT		?
            _41		FLOAT		?
            _42		FLOAT		?
            _43		FLOAT		?
            _44		FLOAT		?

      ;      m FLOAT 4 dup ({?,?,?,?})
     ;   ENDS

    _D3DMATRIX  ENDS
    D3DMATRIX               TYPEDEF		_D3DMATRIX
    LPD3DMATRIX		TYPEDEF		PTR _D3DMATRIX
    D3DMATRIX_DEFINED=1
ENDIF


_D3DVIEWPORT9   struct    DWORD
    X           DWORD       ?   ;
    Y           DWORD       ?   ;  Viewport Top left
    _Width       DWORD       ?   ;<--------------------------can't use 'Width' in Masm.
    Height      DWORD       ?   ;      /* Viewport Dimensions */
    MinZ        FLOAT       ?   ;      /* Min/max of clip Volume */
    MaxZ        FLOAT       ?   ;
_D3DVIEWPORT9   ENDS
D3DVIEWPORT9                TYPEDEF		_D3DVIEWPORT9



;// Max number of user clipping planes, supported in D3D.
D3DMAXUSERCLIPPLANES    EQU 32


;// These bits could be ORed together to use with D3DRS_CLIPPLANEENABLE
;//
D3DCLIPPLANE0 equ 1
D3DCLIPPLANE1 equ 2
D3DCLIPPLANE2 equ 4
D3DCLIPPLANE3 equ 8
D3DCLIPPLANE4 equ 16
D3DCLIPPLANE5 equ 32

;// The following bits are used in the ClipUnion and ClipIntersection
;// members of the D3DCLIPSTATUS9
;//

D3DCS_LEFT  equ 1
D3DCS_RIGHT  equ 2
D3DCS_TOP   equ 4
D3DCS_BOTTOM   equ 8
D3DCS_FRONT    equ 16
D3DCS_BACK     equ 32
D3DCS_PLANE0   equ 64
D3DCS_PLANE1    equ 128
D3DCS_PLANE2   equ 256
D3DCS_PLANE3   equ 512
D3DCS_PLANE4     equ 1024
D3DCS_PLANE5    equ 2048

D3DCS_ALL equ D3DCS_LEFT  or D3DCS_RIGHT or D3DCS_TOP or D3DCS_BOTTOM  or D3DCS_FRONT or D3DCS_BACK or D3DCS_PLANE0 or D3DCS_PLANE1 or D3DCS_PLANE2 or D3DCS_PLANE3 or D3DCS_PLANE4 or D3DCS_PLANE5)

D3DCLIPSTATUS9 struct
    ClipUnion dd ?
    ClipIntersection dd ?
D3DCLIPSTATUS9 ends

_D3DMATERIAL9 struct  DWORD
    Diffuse     D3DCOLORVALUE   <>;         /* Diffuse color RGBA */
    Ambient     D3DCOLORVALUE   <>;         /* Ambient color RGB */
    Specular    D3DCOLORVALUE   <>;         /* Specular 'shininess' */
    Emissive    D3DCOLORVALUE   <>;         /* Emissive color RGB */
    Power       FLOAT           ?;          /* Sharpness if specular highlight */
_D3DMATERIAL9 ENDS
D3DMATERIAL9                TYPEDEF		_D3DMATERIAL9

D3DLIGHT_POINT             EQU       1
D3DLIGHT_SPOT              EQU       2
D3DLIGHT_DIRECTIONAL       EQU       3
D3DLIGHT_FORCE_DWORD       EQU       07fffffffh      ; /* force 32-bit size enum */

D3DLIGHTTYPE        typedef DWORD

_D3DLIGHT9 struct  DWORD
    _Type                D3DLIGHTTYPE        ?   ;   /* Type of light source */<---can't use 'Type' in Masm.
    Diffuse             D3DCOLORVALUE       <>  ;   /* Diffuse color of light */
    Specular            D3DCOLORVALUE       <>  ;   /* Specular color of light */
    Ambient             D3DCOLORVALUE       <>  ;   /* Ambient color of light */
    Position            D3DVECTOR           <>  ;   /* Position in world space */
    Direction           D3DVECTOR           <>  ;   /* Direction in world space */
    Range               FLOAT               ?   ;   /* Cutoff range */
    Falloff             FLOAT               ?   ;   /* Falloff */
    Attenuation0        FLOAT               ?   ;   /* Constant attenuation */
    Attenuation1        FLOAT               ?   ;   /* Linear attenuation */
    Attenuation2        FLOAT               ?   ;   /* Quadratic attenuation */
    Theta               FLOAT               ?   ;   /* Inner angle of spotlight cone */
    Phi                 FLOAT               ?   ;   /* Outer angle of spotlight cone */
_D3DLIGHT9 ENDS
D3DLIGHT9                TYPEDEF		_D3DLIGHT9

D3DCLEAR_TARGET     equ 00000001  ;/* Clear target surface */
D3DCLEAR_ZBUFFER  equ 00000002  ;/* Clear target z buffer */
D3DCLEAR_STENCIL    equ 00000004  ;/* Clear stencil planes */

    D3DSHADE_FLAT   equ 1
    D3DSHADE_GOURAUD equ 2
    D3DSHADE_PHONG equ 3
    D3DSHADE_FORCE_DWORD  equ 7fffffffh;     /* force 32-bit size enum */

    D3DFILL_POINT   equ 1
    D3DFILL_WIREFRAME equ 2
    D3DFILL_SOLID   equ 3
    D3DFILL_FORCE_DWORD  equ 7fffffffh;      /* force 32-bit size enum */

    D3DBLEND_ZERO               equ 1
    D3DBLEND_ONE                equ 2
    D3DBLEND_SRCCOLOR           equ 3
    D3DBLEND_INVSRCCOLOR        equ 4
    D3DBLEND_SRCALPHA           equ 5
    D3DBLEND_INVSRCALPHA        equ 6
    D3DBLEND_DESTALPHA          equ 7
    D3DBLEND_INVDESTALPHA       equ 8
    D3DBLEND_DESTCOLOR          equ 9
    D3DBLEND_INVDESTCOLOR       equ 10

    D3DBLEND_SRCALPHASAT        equ 11
    D3DBLEND_BOTHSRCALPHA       equ 12
    D3DBLEND_BOTHINVSRCALPHA    equ 13
    D3DBLEND_BLENDFACTOR        equ 14; /* Only supported if D3DPBLENDCAPS_BLENDFACTOR is on */
    D3DBLEND_INVBLENDFACTOR     equ 15; /* Only supported if D3DPBLENDCAPS_BLENDFACTOR is on */
    D3DBLEND_FORCE_DWORD     equ 7fffffffh;  /* force 32-bit size enum */

    D3DBLENDOP_ADD     equ 1
    D3DBLENDOP_SUBTRACT    equ 2
    D3DBLENDOP_REVSUBTRACT  equ 3
    D3DBLENDOP_MIN  equ  4
    D3DBLENDOP_MAX  equ 5
    D3DBLENDOP_FORCE_DWORD  equ 7fffffffh;    /* force 32-bit size enum */

    D3DTADDRESS_WRAP     equ 1
    D3DTADDRESS_MIRROR  equ 2
    D3DTADDRESS_CLAMP equ  3
    D3DTADDRESS_BORDER   equ 4
    D3DTADDRESS_MIRRORONCE equ  5
    D3DTADDRESS_FORCE_DWORD  equ 7fffffffh;  /* force 32-bit size enum */

    D3DCULL_NONE equ 1
    D3DCULL_CW      equ 2
    D3DCULL_CCW   equ 3
    D3DCULL_FORCE_DWORD equ 7fffffffh;   /* force 32-bit size enum */

    D3DCMP_NEVER  equ 1
    D3DCMP_LESS  equ 2
    D3DCMP_EQUAL  equ 3
    D3DCMP_LESSEQUAL equ 4
    D3DCMP_GREATER  equ 5
    D3DCMP_NOTEQUAL equ 6
    D3DCMP_GREATEREQUAL equ 7
    D3DCMP_ALWAYS  equ 8
    D3DCMP_FORCE_DWORD equ 7fffffffh;    /* force 32-bit size enum */

    D3DSTENCILOP_KEEP equ 1
    D3DSTENCILOP_ZERO equ 2
    D3DSTENCILOP_REPLACE equ 3
    D3DSTENCILOP_INCRSAT     equ 4
    D3DSTENCILOP_DECRSAT equ 5
    D3DSTENCILOP_INVERT  equ 6
    D3DSTENCILOP_INCR   equ 7
    D3DSTENCILOP_DECR   equ 8
    D3DSTENCILOP_FORCE_DWORD  equ 7fffffffh; /* force 32-bit size enum */

    D3DFOG_NONE  equ 0
    D3DFOG_EXP   equ 1
    D3DFOG_EXP2     equ 2
    D3DFOG_LINEAR equ 3
    D3DFOG_FORCE_DWORD equ 7fffffffh    ; /* force 32-bit size enum */

    D3DZB_FALSE   equ 0
    D3DZB_TRUE       equ 1; // Z buffering
    D3DZB_USEW  equ 2; // W buffering
    D3DZB_FORCE_DWORD   equ 7fffffffh;   /* force 32-bit size enum */

;// Primitives supported by draw-primitive API
    D3DPT_POINTLIST             equ 1
    D3DPT_LINELIST              equ 2
    D3DPT_LINESTRIP             equ 3
    D3DPT_TRIANGLELIST          equ 4
    D3DPT_TRIANGLESTRIP         equ 5
    D3DPT_TRIANGLEFAN           equ 6
    D3DPT_FORCE_DWORD           equ 7fffffffh; /* force 32-bit size enum */

    D3DTS_VIEW     equ  2
    D3DTS_PROJECTION    equ 3
    D3DTS_TEXTURE0      equ 16
    D3DTS_TEXTURE1      equ 17
    D3DTS_TEXTURE2      equ 18
    D3DTS_TEXTURE3      equ 19
    D3DTS_TEXTURE4      equ 20


    D3DTS_TEXTURE5      equ 21
    D3DTS_TEXTURE6      equ 22
    D3DTS_TEXTURE7      equ 23
    D3DTS_FORCE_DWORD   equ 7fffffffh;   /* force 32-bit size enum */

D3DTS_WORLDMATRIX MACRO index
	local DefineAs
	DefineAs EQU (D3DTRANSFORMSTATETYPE)(index + 256)
	EXITM DefineAs
ENDM D3DTS_WORLDMATRIX
;#define D3DTS_WORLD  D3DTS_WORLDMATRIX(0)
D3DTS_WORLD EQU D3DTS_WORLDMATRIX 0
;#define D3DTS_WORLD1 D3DTS_WORLDMATRIX(1)
D3DTS_WORLD1 EQU D3DTS_WORLDMATRIX 1
;#define D3DTS_WORLD2 D3DTS_WORLDMATRIX(2)
D3DTS_WORLD2 EQU D3DTS_WORLDMATRIX 2
;#define D3DTS_WORLD3 D3DTS_WORLDMATRIX(3)
D3DTS_WORLD3 EQU D3DTS_WORLDMATRIX 3

    D3DRS_ZENABLE                   EQU    7      ;    /* D3DZBUFFERTYPE (or TRUE/FALSE for legacy) */
    D3DRS_FILLMODE                  EQU    8      ;    /* D3DFILL_MODE        */
    D3DRS_SHADEMODE                 EQU    9      ;    /* D3DSHADEMODE */
    D3DRS_LINEPATTERN               EQU    10      ;   /* D3DLINEPATTERN */
    D3DRS_ZWRITEENABLE              EQU    14      ;   /* TRUE to enable z writes */
    D3DRS_ALPHATESTENABLE           EQU    15      ;   /* TRUE to enable alpha tests */
    D3DRS_LASTPIXEL                 EQU    16      ;   /* TRUE for last-pixel on lines */
    D3DRS_SRCBLEND                  EQU    19      ;   /* D3DBLEND */
    D3DRS_DESTBLEND                 EQU    20      ;   /* D3DBLEND */
    D3DRS_CULLMODE                  EQU    22      ;   /* D3DCULL */
    D3DRS_ZFUNC                     EQU    23      ;   /* D3DCMPFUNC */
    D3DRS_ALPHAREF                  EQU    24      ;   /* D3DFIXED */
    D3DRS_ALPHAFUNC                 EQU    25      ;   /* D3DCMPFUNC */
    D3DRS_DITHERENABLE              EQU    26      ;   /* TRUE to enable dithering */
    D3DRS_ALPHABLENDENABLE          EQU    27      ;   /* TRUE to enable alpha blending */
    D3DRS_FOGENABLE                 EQU    28      ;   /* TRUE to enable fog blending */
    D3DRS_SPECULARENABLE            EQU    29      ;   /* TRUE to enable specular */
    D3DRS_ZVISIBLE                  EQU    30      ;   /* TRUE to enable z checking */
    D3DRS_FOGCOLOR                  EQU    34      ;   /* D3DCOLOR */
    D3DRS_FOGTABLEMODE              EQU    35      ;   /* D3DFOGMODE */
    D3DRS_FOGSTART                  EQU    36      ;   /* Fog start (for both vertex and pixel fog) */
    D3DRS_FOGEND                    EQU    37      ;   /* Fog end      */
    D3DRS_FOGDENSITY                EQU    38      ;   /* Fog density  */
    D3DRS_EDGEANTIALIAS             EQU    40      ;   /* TRUE to enable edge antialiasing */
    D3DRS_ZBIAS                     EQU    47      ;   /* LONG Z bias */
    D3DRS_RANGEFOGENABLE            EQU    48      ;   /* Enables range-based fog */
    D3DRS_STENCILENABLE             EQU    52      ;   /* BOOL enable/disable stenciling */
    D3DRS_STENCILFAIL               EQU    53      ;   /* D3DSTENCILOP to do if stencil test fails */
    D3DRS_STENCILZFAIL              EQU    54      ;   /* D3DSTENCILOP to do if stencil test passes and Z test fails */
    D3DRS_STENCILPASS               EQU    55      ;   /* D3DSTENCILOP to do if both stencil and Z tests pass */
    D3DRS_STENCILFUNC               EQU    56      ;   /* D3DCMPFUNC fn.  Stencil Test passes if ((ref & mask) stencilfn (stencil & mask)) is true */
    D3DRS_STENCILREF                EQU    57      ;   /* Reference value used in stencil test */
    D3DRS_STENCILMASK               EQU    58      ;   /* Mask value used in stencil test */
    D3DRS_STENCILWRITEMASK          EQU    59      ;   /* Write mask applied to values written to stencil buffer */
    D3DRS_TEXTUREFACTOR             EQU    60      ;   /* D3DCOLOR used for multi-texture blend */
    D3DRS_WRAP0                     EQU    128      ;  /* wrap for 1st texture coord. set */
    D3DRS_WRAP1                     EQU    129      ;  /* wrap for 2nd texture coord. set */
    D3DRS_WRAP2                     EQU    130      ;  /* wrap for 3rd texture coord. set */
    D3DRS_WRAP3                     EQU    131      ;  /* wrap for 4th texture coord. set */
    D3DRS_WRAP4                     EQU    132      ;  /* wrap for 5th texture coord. set */
    D3DRS_WRAP5                     EQU    133      ;  /* wrap for 6th texture coord. set */
    D3DRS_WRAP6                     EQU    134      ;  /* wrap for 7th texture coord. set */
    D3DRS_WRAP7                     EQU    135      ;  /* wrap for 8th texture coord. set */
    D3DRS_CLIPPING                  EQU    136      ;
    D3DRS_LIGHTING                  EQU    137      ;
    D3DRS_AMBIENT                   EQU    139      ;
    D3DRS_FOGVERTEXMODE             EQU    140      ;
    D3DRS_COLORVERTEX               EQU    141      ;
    D3DRS_LOCALVIEWER               EQU    142      ;
    D3DRS_NORMALIZENORMALS          EQU    143      ;
    D3DRS_DIFFUSEMATERIALSOURCE     EQU    145      ;
    D3DRS_SPECULARMATERIALSOURCE    EQU    146      ;
    D3DRS_AMBIENTMATERIALSOURCE     EQU    147      ;
    D3DRS_EMISSIVEMATERIALSOURCE    EQU    148      ;
    D3DRS_VERTEXBLEND               EQU    151      ;
    D3DRS_CLIPPLANEENABLE           EQU    152      ;
    D3DRS_SOFTWAREVERTEXPROCESSING  EQU    153      ;
    D3DRS_POINTSIZE                 EQU    154      ;   /* float point size */
    D3DRS_POINTSIZE_MIN             EQU    155      ;   /* float point size min threshold */
    D3DRS_POINTSPRITEENABLE         EQU    156      ;   /* BOOL point texture coord control */
    D3DRS_POINTSCALEENABLE          EQU    157      ;   /* BOOL point size scale enable */
    D3DRS_POINTSCALE_A              EQU    158      ;   /* float point attenuation A value */
    D3DRS_POINTSCALE_B              EQU    159      ;   /* float point attenuation B value */
    D3DRS_POINTSCALE_C              EQU    160      ;   /* float point attenuation C value */
    D3DRS_MULTISAMPLEANTIALIAS      EQU    161      ;  // BOOL - set to do FSAA with multisample buffer
    D3DRS_MULTISAMPLEMASK           EQU    162      ;  // DWORD - per-sample enable/disable
    D3DRS_PATCHEDGESTYLE            EQU    163      ;  // Sets whether patch edges will use float style tessellation
    D3DRS_PATCHSEGMENTS             EQU    164      ;  // Number of segments per edge when drawing patches
    D3DRS_DEBUGMONITORTOKEN         EQU    165      ;  // DEBUG ONLY - token to debug monitor
    D3DRS_POINTSIZE_MAX             EQU    166      ;   /* float point size max threshold */
    D3DRS_INDEXEDVERTEXBLENDENABLE  EQU    167      ;
    D3DRS_COLORWRITEENABLE          EQU    168      ;  // per-channel write enable
    D3DRS_TWEENFACTOR               EQU    170      ;   // float tween factor
    D3DRS_BLENDOP                   EQU    171      ;   // D3DBLENDOP setting
    D3DRS_POSITIONDEGREE            EQU    172;   // NPatch position interpolation degree. D3DDEGREE_LINEAR or D3DDEGREE_CUBIC (default)
    D3DRS_NORMALDEGREE              EQU    173;   // NPatch normal interpolation degree. D3DDEGREE_LINEAR (default) or D3DDEGREE_QUADRATIC
    D3DRS_SCISSORTESTENABLE         EQU    174
    D3DRS_SLOPESCALEDEPTHBIAS       EQU    175
    D3DRS_ANTIALIASEDLINEENABLE     EQU    176
    D3DRS_MINTESSELLATIONLEVEL      EQU    178
    D3DRS_MAXTESSELLATIONLEVEL      EQU    179
    D3DRS_ADAPTIVETESS_X            EQU    180
    D3DRS_ADAPTIVETESS_Y            EQU    181
    D3DRS_ADAPTIVETESS_Z            EQU    182
    D3DRS_ADAPTIVETESS_W            EQU    183
    D3DRS_ENABLEADAPTIVETESSELLATION EQU    184
    D3DRS_TWOSIDEDSTENCILMODE       EQU    185;  /* BOOL enable/disable 2 sided stenciling */
    D3DRS_CCW_STENCILFAIL           EQU    186;   /* D3DSTENCILOP to do if ccw stencil test fails */
    D3DRS_CCW_STENCILZFAIL          EQU    187;   /* D3DSTENCILOP to do if ccw stencil test passes and Z test fails */
    D3DRS_CCW_STENCILPASS           EQU    188;   /* D3DSTENCILOP to do if both ccw stencil and Z tests pass */
    D3DRS_CCW_STENCILFUNC           EQU    189;   /* D3DCMPFUNC fn.  ccw Stencil Test passes if ((ref & mask) stencilfn (stencil & mask)) is true */
    D3DRS_COLORWRITEENABLE1         EQU    190;   /* Additional ColorWriteEnables for the devices that support D3DPMISCCAPS_INDEPENDENTWRITEMASKS */
    D3DRS_COLORWRITEENABLE2         EQU    191;   /* Additional ColorWriteEnables for the devices that support D3DPMISCCAPS_INDEPENDENTWRITEMASKS */
    D3DRS_COLORWRITEENABLE3         EQU    192;   /* Additional ColorWriteEnables for the devices that support D3DPMISCCAPS_INDEPENDENTWRITEMASKS */
    D3DRS_BLENDFACTOR               EQU    193;   /* D3DCOLOR used for a constant blend factor during alpha blending for devices that support D3DPBLENDCAPS_BLENDFACTOR */
    D3DRS_SRGBWRITEENABLE           EQU    194;   /* Enable rendertarget writes to be DE-linearized to SRGB (for formats that expose D3DUSAGE_QUERY_SRGBWRITE) */
    D3DRS_DEPTHBIAS                 EQU    195
    D3DRS_WRAP8                     EQU    198;   /* Additional wrap states for vs_3_0+ attributes with D3DDECLUSAGE_TEXCOORD */
    D3DRS_WRAP9                     EQU    199
    D3DRS_WRAP10                    EQU    200
    D3DRS_WRAP11                    EQU    201
    D3DRS_WRAP12                    EQU    202
    D3DRS_WRAP13                    EQU    203
    D3DRS_WRAP14                    EQU    204
    D3DRS_WRAP15                    EQU    205
    D3DRS_SEPARATEALPHABLENDENABLE  EQU    206; /* TRUE to enable a separate blending function for the alpha channel */
    D3DRS_SRCBLENDALPHA             EQU    207;  /* SRC blend factor for the alpha channel when D3DRS_SEPARATEDESTALPHAENABLE is TRUE */
    D3DRS_DESTBLENDALPHA            EQU    208;  /* DST blend factor for the alpha channel when D3DRS_SEPARATEDESTALPHAENABLE is TRUE */
    D3DRS_BLENDOPALPHA              EQU    209;  /* Blending operation for the alpha channel when D3DRS_SEPARATEDESTALPHAENABLE is TRUE */
    D3DRS_FORCE_DWORD               EQU    7fffffffh;    /* force 32-bit size enum */

;// Maximum number of simultaneous render targets D3D supports
D3D_MAX_SIMULTANEOUS_RENDERTARGETS equ 4

;// Values for material source
    D3DMCS_MATERIAL                 EQU    0    ;            // Color from material is used
    D3DMCS_COLOR1                   EQU    1    ;            // Diffuse vertex color is used
    D3DMCS_COLOR2                   EQU    2    ;            // Specular vertex color is used
    D3DMCS_FORCE_DWORD              EQU    07fffffffh   ;,   // force 32-bit size enum
D3DMATERIALCOLORSOURCE               TYPEDEF             DWORD

;// Bias to apply to the texture coordinate set to apply a wrap to.
D3DRENDERSTATE_WRAPBIAS                 EQU     128         ;128UL

;/* Flags to construct the WRAP render states */
D3DWRAP_U                   EQU            00000001h     ;0x00000001L
D3DWRAP_V                   EQU            00000002h     ;0x00000002L
D3DWRAP_W                   EQU            00000004h     ;0x00000004L

;/* Flags to construct the WRAP render states for 1D thru 4D texture coordinates */
D3DWRAPCOORD_0              EQU            00000001h     ;0x00000001L    // same as D3DWRAP_U
D3DWRAPCOORD_1              EQU            00000002h     ;0x00000002L    // same as D3DWRAP_V
D3DWRAPCOORD_2              EQU            00000004h     ;0x00000004L    // same as D3DWRAP_W
D3DWRAPCOORD_3              EQU            00000008h     ;0x00000008L


;/* Flags to construct D3DRS_COLORWRITEENABLE */
D3DCOLORWRITEENABLE_RED    equ 1
D3DCOLORWRITEENABLE_GREEN equ 2
D3DCOLORWRITEENABLE_BLUE equ 4
D3DCOLORWRITEENABLE_ALPHA  equ 8

    D3DTSS_COLOROP        equ 1; /* D3DTEXTUREOP - per-stage blending controls for color channels */
    D3DTSS_COLORARG1      equ 2; /* D3DTA_* (texture arg) */
    D3DTSS_COLORARG2      equ 3; /* D3DTA_* (texture arg) */
    D3DTSS_ALPHAOP        equ 4; /* D3DTEXTUREOP - per-stage blending controls for alpha channel */
    D3DTSS_ALPHAARG1      equ 5; /* D3DTA_* (texture arg) */
    D3DTSS_ALPHAARG2      equ 6; /* D3DTA_* (texture arg) */
    D3DTSS_BUMPENVMAT00   equ 7; /* float (bump mapping matrix) */
    D3DTSS_BUMPENVMAT01   equ 8; /* float (bump mapping matrix) */
    D3DTSS_BUMPENVMAT10   equ 9; /* float (bump mapping matrix) */
    D3DTSS_BUMPENVMAT11   equ 10; /* float (bump mapping matrix) */
    D3DTSS_TEXCOORDINDEX  equ 11; /* identifies which set of texture coordinates index this texture */
    D3DTSS_BUMPENVLSCALE  equ 22; /* float scale for bump map luminance */
    D3DTSS_BUMPENVLOFFSET equ 23; /* float offset for bump map luminance */
    D3DTSS_TEXTURETRANSFORMFLAGS equ 24; /* D3DTEXTURETRANSFORMFLAGS controls texture transform */
    D3DTSS_COLORARG0      equ 26; /* D3DTA_* third arg for triadic ops */
    D3DTSS_ALPHAARG0      equ 27; /* D3DTA_* third arg for triadic ops */
    D3DTSS_RESULTARG      equ 28; /* D3DTA_* arg for result (CURRENT or TEMP) */
    D3DTSS_CONSTANT       equ 32; /* Per-stage constant D3DTA_CONSTANT */
    D3DTSS_FORCE_DWORD   equ 7fffffffh;  /* force 32-bit size enum */

    D3DSAMP_ADDRESSU       equ 1;  /* D3DTEXTUREADDRESS for U coordinate */
    D3DSAMP_ADDRESSV       equ 2;  /* D3DTEXTUREADDRESS for V coordinate */
    D3DSAMP_ADDRESSW       equ 3;  /* D3DTEXTUREADDRESS for W coordinate */
    D3DSAMP_BORDERCOLOR    equ 4;  /* D3DCOLOR */
    D3DSAMP_MAGFILTER      equ 5;  /* D3DTEXTUREFILTER filter to use for magnification */
    D3DSAMP_MINFILTER      equ 6;  /* D3DTEXTUREFILTER filter to use for minification */
    D3DSAMP_MIPFILTER      equ 7;  /* D3DTEXTUREFILTER filter to use between mipmaps during minification */
    D3DSAMP_MIPMAPLODBIAS  equ 8;  /* float Mipmap LOD bias */
    D3DSAMP_MAXMIPLEVEL    equ 9;  /* DWORD 0..(n-1) LOD index of largest map to use (0 == largest) */
    D3DSAMP_MAXANISOTROPY  equ 10; /* DWORD maximum anisotropy */
    D3DSAMP_SRGBTEXTURE    equ 11; /* Default = 0 (which means Gamma 1.0, no correction required.) else correct for Gamma = 2.2 */
    D3DSAMP_ELEMENTINDEX   equ 12; /* When multi-element texture is assigned to sampler, this indicates which element index to use.  Default = 0.  */
    D3DSAMP_DMAPOFFSET     equ 13; /* Offset in vertices in the pre-sampled displacement map. Only valid for D3DDMAPSAMPLER sampler  */
    D3DSAMP_FORCE_DWORD   equ 7fffffffh; /* force 32-bit size enum */

;/* Special sampler which is used in the tesselator */
D3DDMAPSAMPLER equ 256

;// Samplers used in vertex shaders
D3DVERTEXTEXTURESAMPLER0 equ (D3DDMAPSAMPLER+1)
D3DVERTEXTEXTURESAMPLER1 equ (D3DDMAPSAMPLER+2)
D3DVERTEXTEXTURESAMPLER2 equ (D3DDMAPSAMPLER+3)
D3DVERTEXTEXTURESAMPLER3 equ (D3DDMAPSAMPLER+4)

;// Values, used with D3DTSS_TEXCOORDINDEX, to specify that the vertex data(position
;// and normal in the camera space) should be taken as texture coordinates
;// Low 16 bits are used to specify texture coordinate index, to take the WRAP mode from
;//
D3DTSS_TCI_PASSTHRU                          equ 0
D3DTSS_TCI_CAMERASPACENORMAL     equ 00010000h
D3DTSS_TCI_CAMERASPACEPOSITION      equ 00020000h
D3DTSS_TCI_CAMERASPACEREFLECTIONVECTOR    equ 00030000h
D3DTSS_TCI_SPHEREMAP             equ 00040000h


    ;// Control
    D3DTOP_DISABLE                  EQU     1      ;// disables stage
    D3DTOP_SELECTARG1               EQU     2      ;// the default
    D3DTOP_SELECTARG2               EQU     3

    ;// Modulate
    D3DTOP_MODULATE                 EQU     4      ;// multiply args together
    D3DTOP_MODULATE2X               EQU     5      ;// multiply and  1 bit
    D3DTOP_MODULATE4X               EQU     6      ;// multiply and  2 bits

    ;// Add
    D3DTOP_ADD                      EQU      7      ;// add arguments together
    D3DTOP_ADDSIGNED                EQU      8      ;// add with -0.5 bias
    D3DTOP_ADDSIGNED2X              EQU      9      ;// as above but left  1 bit
    D3DTOP_SUBTRACT                 EQU     10      ;// Arg1 - Arg2, with no saturation
    D3DTOP_ADDSMOOTH                EQU     11      ;// add 2 args, subtract product
                                                    ;// Arg1 + Arg2 - Arg1*Arg2
                                                    ;// =Arg1 + (1-Arg1)*Arg2

    ;// Linear alpha blend: Arg1*(Alpha) + Arg2*(1-Alpha)
    D3DTOP_BLENDDIFFUSEALPHA        EQU     12      ;// iterated alpha
    D3DTOP_BLENDTEXTUREALPHA        EQU     13      ;// texture alpha
    D3DTOP_BLENDFACTORALPHA         EQU     14      ;// alpha from D3DRENDERSTATE_TEXTUREFACTOR

    ;// Linear alpha blend with pre-multiplied arg1 input: Arg1 + Arg2*(1-Alpha)
    D3DTOP_BLENDTEXTUREALPHAPM      EQU     15      ;// texture alpha
    D3DTOP_BLENDCURRENTALPHA        EQU     16      ;// by alpha of current color

    ;// Specular mapping
    D3DTOP_PREMODULATE              EQU     17      ;// modulate with next texture before use
    D3DTOP_MODULATEALPHA_ADDCOLOR   EQU     18      ;// Arg1.RGB + Arg1.A*Arg2.RGB
                                            ;// COLOROP only
    D3DTOP_MODULATECOLOR_ADDALPHA   EQU     19     ;// Arg1.RGB*Arg2.RGB + Arg1.A
                                            ;// COLOROP only
    D3DTOP_MODULATEINVALPHA_ADDCOLOR    EQU     20  ;// (1-Arg1.A)*Arg2.RGB + Arg1.RGB
                                            ;// COLOROP only
    D3DTOP_MODULATEINVCOLOR_ADDALPHA    EQU     21  ;// (1-Arg1.RGB)*Arg2.RGB + Arg1.A
                                            ;// COLOROP only

    ;// Bump mapping
    D3DTOP_BUMPENVMAP               EQU     22      ;// per pixel env map perturbation
    D3DTOP_BUMPENVMAPLUMINANCE      EQU     23      ;// with luminance channel

    ;// This can do either diffuse or specular bump mapping with correct input.
    ;// Performs the function (Arg1.R*Arg2.R + Arg1.G*Arg2.G + Arg1.B*Arg2.B)
    ;// where each component has been scaled and offset to make it signed.
    ;// The result is replicated into all four (including alpha) channels.
    ;// This is a valid COLOROP only.
    D3DTOP_DOTPRODUCT3              EQU     24

    ;// Triadic ops
    D3DTOP_MULTIPLYADD              EQU     25      ;// Arg0 + Arg1*Arg2
    D3DTOP_LERP                     EQU     26      ;// (Arg0)*Arg1 + (1-Arg0)*Arg2

    D3DTOP_FORCE_DWORD     EQU     7fffffffh        ;0x7fffffff
D3DTEXTUREOP                TYPEDEF             DWORD 

D3DTA_SELECTMASK            EQU     0000000fh    ;0x0000000f  ;// mask for arg selector
D3DTA_DIFFUSE               EQU     00000000h    ;0x00000000  ;// select diffuse color (read only)
D3DTA_CURRENT               EQU     00000001h    ;0x00000001  ;// select stage destination register (read/write)
D3DTA_TEXTURE               EQU     00000002h    ;0x00000002  ;// select texture color (read only)
D3DTA_TFACTOR               EQU     00000003h    ;0x00000003  ;// select RENDERSTATE_TEXTUREFACTOR (read only)
D3DTA_SPECULAR              EQU     00000004h    ;0x00000004  ;// select specular color (read only)
D3DTA_TEMP                  EQU     00000005h    ;0x00000005  ;// select temporary register color (read/write)
D3DTA_COMPLEMENT            EQU     00000010h    ;0x00000010  ;// take 1.0 - x (read modifier)
D3DTA_ALPHAREPLICATE        EQU     00000020h    ;0x00000020  ;// replicate alpha to color components (read modifier)


    D3DTEXF_NONE equ 0;    // filtering disabled (valid for mip filter only)
    D3DTEXF_POINT           equ 1;    // nearest
    D3DTEXF_LINEAR          equ 2;    // linear interpolation
    D3DTEXF_ANISOTROPIC     equ 3;    // anisotropic
    D3DTEXF_PYRAMIDALQUAD   equ 6;    // 4-sample tent
    D3DTEXF_GAUSSIANQUAD    equ 7;    // 4-sample gaussian
    D3DTEXF_FORCE_DWORD     equ 07fffffffh;   // force 32-bit size enum


D3DPV_DONOTCOPYDATA  equ 1

;//-------------------------------------------------------------------
;// Flexible vertex format bits
;//
D3DFVF_RESERVED0        equ 001h
D3DFVF_POSITION_MASK    equ 400Eh
D3DFVF_XYZ              equ 002h
D3DFVF_XYZRHW           equ 004h
D3DFVF_XYZB1            equ 006h
D3DFVF_XYZB2            equ 008h
D3DFVF_XYZB3            equ 00ah
D3DFVF_XYZB4            equ 00ch
D3DFVF_XYZB5            equ 00eh
D3DFVF_XYZW             equ 4002h

D3DFVF_NORMAL           equ 010h
D3DFVF_PSIZE            equ 020h
D3DFVF_DIFFUSE          equ 040h
D3DFVF_SPECULAR         equ 080h

D3DFVF_TEXCOUNT_MASK    equ f00h
D3DFVF_TEXCOUNT_SHIFT   equ 8
D3DFVF_TEX0             equ 000h
D3DFVF_TEX1             equ 100h
D3DFVF_TEX2             equ 200h
D3DFVF_TEX3             equ 300h
D3DFVF_TEX4             equ 400h
D3DFVF_TEX5             equ 500h
D3DFVF_TEX6             equ 600h
D3DFVF_TEX7             equ 700h
D3DFVF_TEX8             equ 800h

D3DFVF_LASTBETA_UBYTE4   equ 1000h
D3DFVF_LASTBETA_D3DCOLOR equ 8000h

D3DFVF_RESERVED2 equ 6000h ; // 2 reserved bits

;//---------------------------------------------------------------------
;// Vertex Shaders
;//
;// Vertex shader declaration

;// Vertex element semantics
;//
    D3DDECLUSAGE_POSITION equ 0
    D3DDECLUSAGE_BLENDWEIGHT equ 1
    D3DDECLUSAGE_BLENDINDICES equ 2
    D3DDECLUSAGE_NORMAL equ 3
    D3DDECLUSAGE_PSIZE equ 4
    D3DDECLUSAGE_TEXCOORD equ 5
    D3DDECLUSAGE_TANGENT equ  6
    D3DDECLUSAGE_BINORMAL equ 7
    D3DDECLUSAGE_TESSFACTOR equ 8
    D3DDECLUSAGE_POSITIONT equ 9
    D3DDECLUSAGE_COLOR equ 10
    D3DDECLUSAGE_FOG equ 11
    D3DDECLUSAGE_DEPTH equ 2
    D3DDECLUSAGE_SAMPLE equ 13

MAXD3DDECLUSAGE        equ D3DDECLUSAGE_SAMPLE
MAXD3DDECLUSAGEINDEX   equ 15
MAXD3DDECLLENGTH        equ 64 ;        // does not include "end" marker vertex element

    D3DDECLMETHOD_DEFAULT equ 0
    D3DDECLMETHOD_PARTIALU equ 1
    D3DDECLMETHOD_PARTIALV equ 2
    D3DDECLMETHOD_CROSSUV equ 3
    D3DDECLMETHOD_UV equ 4
    D3DDECLMETHOD_LOOKUP equ 5;               // Lookup a displacement map
    D3DDECLMETHOD_LOOKUPPRESAMPLED equ 6;     // Lookup a pre-sampled displacement map
MAXD3DDECLMETHOD equ D3DDECLMETHOD_LOOKUPPRESAMPLED

;// Declarations for _Type fields
    D3DDECLTYPE_FLOAT1   equ   0;  // 1D float expanded to (value, 0., 0., 1.)
    D3DDECLTYPE_FLOAT2    equ 1;  // 2D float expanded to (value, value, 0., 1.)
    D3DDECLTYPE_FLOAT3    equ 2;  // 3D float expanded to (value, value, value, 1.)
    D3DDECLTYPE_FLOAT4    equ 3;  // 4D float
    D3DDECLTYPE_D3DCOLOR  equ 4;  // 4D packed unsigned bytes mapped to 0. to 1. range
                               ;  // Input is in D3DCOLOR format (ARGB) expanded to (R, G, B, A)
    D3DDECLTYPE_UBYTE4    equ 5;  // 4D unsigned byte
    D3DDECLTYPE_SHORT2    equ 6;  // 2D signed short expanded to (value, value, 0., 1.)
    D3DDECLTYPE_SHORT4    equ 7;  // 4D signed short

;// The following types are valid only with vertex shaders >= 2.0
    D3DDECLTYPE_UBYTE4N   equ 8;  // Each of 4 bytes is normalized by dividing to 255.0
    D3DDECLTYPE_SHORT2N   equ 9;  // 2D signed short normalized (v[0]/32767.0,v[1]/32767.0,0,1)
    D3DDECLTYPE_SHORT4N   equ 10;  // 4D signed short normalized (v[0]/32767.0,v[1]/32767.0,v[2]/32767.0,v[3]/32767.0)
    D3DDECLTYPE_USHORT2N  equ 11;  // 2D unsigned short normalized (v[0]/65535.0,v[1]/65535.0,0,1)
    D3DDECLTYPE_USHORT4N  equ 12;  // 4D unsigned short normalized (v[0]/65535.0,v[1]/65535.0,v[2]/65535.0,v[3]/65535.0)
    D3DDECLTYPE_UDEC3     equ 13;  // 3D unsigned 10 10 10 format expanded to (value, value, value, 1)
    D3DDECLTYPE_DEC3N     equ 14;  // 3D signed 10 10 10 format normalized and expanded to (v[0]/511.0, v[1]/511.0, v[2]/511.0, 1)
    D3DDECLTYPE_FLOAT16_2 equ 15;  // Two 16-bit floating point values, expanded to (value, value, 0, 1)
    D3DDECLTYPE_FLOAT16_4 equ 16;  // Four 16-bit floating point values
    D3DDECLTYPE_UNUSED    equ 17;  // When the type field in a decl is unused.
MAXD3DDECLTYPE    equ  D3DDECLTYPE_UNUSED

D3DVERTEXELEMENT9 struct
    Stream WORD ?;     // Stream index
    _Offset WORD ?;     // Offset in the stream in bytes
    _Type BYTE ?;       // Data type
    Method BYTE ?;     // Processing method
    Usage BYTE ?;      // Semantics
    UsageIndex BYTE ?; // Semantic index
D3DVERTEXELEMENT9 ends
LPD3DVERTEXELEMENT9 typedef ptr D3DVERTEXELEMENT9

;// This is used to initialize the last vertex element in a vertex declaration array
;D3DDECL_END() {0xFF,0,D3DDECLTYPE_UNUSED,0,0,0}

;// Maximum supported number of texture coordinate sets
D3DDP_MAXTEXCOORD   equ 8


;//---------------------------------------------------------------------
;//
;// The internal format of Pixel Shader (PS) & Vertex Shader (VS)
;// Instruction Tokens is defined in the Direct3D Device Driver Kit
;//
;//---------------------------------------------------------------------

;//
;// Instruction Token Bit Definitions
;//
D3DSI_OPCODE_MASK equ 0000FFFFh
D3DSI_INSTLENGTH_MASK equ 0F000000h
D3DSI_INSTLENGTH_SHIFT  equ 24

 ; typedef enum _D3DSHADER_INSTRUCTION_OPCODE_TYPE
 ; {
 ;     D3DSIO_NOP          = 0,
 ;     D3DSIO_MOV          ,
 ;     D3DSIO_ADD          ,
 ;     D3DSIO_SUB          ,
 ;     D3DSIO_MAD          ,
 ;     D3DSIO_MUL          ,
 ;     D3DSIO_RCP          ,
 ;     D3DSIO_RSQ          ,
 ;     D3DSIO_DP3          ,
 ;     D3DSIO_DP4          ,
 ;     D3DSIO_MIN          ,
 ;     D3DSIO_MAX          ,
 ;     D3DSIO_SLT          ,
 ;     D3DSIO_SGE          ,
 ;     D3DSIO_EXP          ,
 ;     D3DSIO_LOG          ,
 ;     D3DSIO_LIT          ,
 ;     D3DSIO_DST          ,
 ;     D3DSIO_LRP          ,
 ;     D3DSIO_FRC          ,
 ;     D3DSIO_M4x4         ,
 ;     D3DSIO_M4x3         ,
 ;     D3DSIO_M3x4         ,
 ;     D3DSIO_M3x3         ,
 ;     D3DSIO_M3x2         ,
 ;     D3DSIO_CALL         ,
 ;     D3DSIO_CALLNZ       ,
 ;     D3DSIO_LOOP         ,
 ;     D3DSIO_RET          ,
 ;     D3DSIO_ENDLOOP      ,
 ;     D3DSIO_LABEL        ,
 ;     D3DSIO_DCL          ,
 ;     D3DSIO_POW          ,
 ;     D3DSIO_CRS          ,
 ;     D3DSIO_SGN          ,
 ;     D3DSIO_ABS          ,
 ;     D3DSIO_NRM          ,
 ;     D3DSIO_SINCOS       ,
 ;     D3DSIO_REP          ,
 ;     D3DSIO_ENDREP       ,
 ;     D3DSIO_IF           ,
 ;     D3DSIO_IFC          ,
 ;     D3DSIO_ELSE         ,
 ;     D3DSIO_ENDIF        ,
 ;     D3DSIO_BREAK        ,
 ;     D3DSIO_BREAKC       ,
 ;     D3DSIO_MOVA         ,
 ;     D3DSIO_DEFB         ,
 ;     D3DSIO_DEFI         ,
 ; 
 ;     D3DSIO_TEXCOORD     = 64,
 ;     D3DSIO_TEXKILL      ,
 ;     D3DSIO_TEX          ,
 ;     D3DSIO_TEXBEM       ,
 ;     D3DSIO_TEXBEML      ,
 ;     D3DSIO_TEXREG2AR    ,
 ;     D3DSIO_TEXREG2GB    ,
 ;     D3DSIO_TEXM3x2PAD   ,
 ;     D3DSIO_TEXM3x2TEX   ,
 ;     D3DSIO_TEXM3x3PAD   ,
 ;     D3DSIO_TEXM3x3TEX   ,
 ;     D3DSIO_RESERVED0    ,
 ;     D3DSIO_TEXM3x3SPEC  ,
 ;     D3DSIO_TEXM3x3VSPEC ,
 ;     D3DSIO_EXPP         ,
 ;     D3DSIO_LOGP         ,
 ;     D3DSIO_CND          ,
 ;     D3DSIO_DEF          ,
 ;     D3DSIO_TEXREG2RGB   ,
 ;     D3DSIO_TEXDP3TEX    ,
 ;     D3DSIO_TEXM3x2DEPTH ,
 ;     D3DSIO_TEXDP3       ,
 ;     D3DSIO_TEXM3x3      ,
 ;     D3DSIO_TEXDEPTH     ,
 ;     D3DSIO_CMP          ,
 ;     D3DSIO_BEM          ,
 ;     D3DSIO_DP2ADD       ,
 ;     D3DSIO_DSX          ,
 ;     D3DSIO_DSY          ,
 ;     D3DSIO_TEXLDD       ,
 ;     D3DSIO_SETP         ,
 ;     D3DSIO_TEXLDL       ,
 ;     D3DSIO_BREAKP       ,
 ; 
 ;     D3DSIO_PHASE        = 0xFFFD,
 ;     D3DSIO_COMMENT      = 0xFFFE,
 ;     D3DSIO_END          = 0xFFFF,
 ; 
 ;     D3DSIO_FORCE_DWORD  = 0x7fffffff,   // force 32-bit size enum
 ; } D3DSHADER_INSTRUCTION_OPCODE_TYPE;
 ; 
 ; //---------------------------------------------------------------------
 ; // Use these constants with D3DSIO_SINCOS macro as SRC2, SRC3
 ; //
 ; #define D3DSINCOSCONST1 -1.5500992e-006f, -2.1701389e-005f,  0.0026041667f, 0.00026041668f
 ; #define D3DSINCOSCONST2 -0.020833334f, -0.12500000f, 1.0f, 0.50000000f
 ; 
 ; //---------------------------------------------------------------------
 ; // Co-Issue Instruction Modifier - if set then this instruction is to be
 ; // issued in parallel with the previous instruction(s) for which this bit
 ; // is not set.
 ; //
 ; #define D3DSI_COISSUE           0x40000000
 ; 
 ; //---------------------------------------------------------------------
 ; // Opcode specific controls
 ; 
 ; #define D3DSP_OPCODESPECIFICCONTROL_MASK  0x00ff0000
 ; #define D3DSP_OPCODESPECIFICCONTROL_SHIFT 16
 ; 
 ; // ps_2_0 texld controls
 ; #define D3DSI_TEXLD_PROJECT (0x01 << D3DSP_OPCODESPECIFICCONTROL_SHIFT)
 ; #define D3DSI_TEXLD_BIAS    (0x02 << D3DSP_OPCODESPECIFICCONTROL_SHIFT)
 ; 
 ; // Comparison for dynamic conditional instruction opcodes (i.e. if, breakc)
 ; typedef enum _D3DSHADER_COMPARISON
 ; {
 ;                          // < = >
 ;     D3DSPC_RESERVED0= 0, // 0 0 0
 ;     D3DSPC_GT       = 1, // 0 0 1
 ;     D3DSPC_EQ       = 2, // 0 1 0
 ;     D3DSPC_GE       = 3, // 0 1 1
 ;     D3DSPC_LT       = 4, // 1 0 0
 ;     D3DSPC_NE       = 5, // 1 0 1
 ;     D3DSPC_LE       = 6, // 1 1 0
 ;     D3DSPC_RESERVED1= 7  // 1 1 1
 ; } D3DSHADER_COMPARISON;
 ; 
 ; // Comparison is part of instruction opcode token:
 ; #define D3DSHADER_COMPARISON_SHIFT D3DSP_OPCODESPECIFICCONTROL_SHIFT
 ; #define D3DSHADER_COMPARISON_MASK  (0x7<<D3DSHADER_COMPARISON_SHIFT)
 ; 
 ; //---------------------------------------------------------------------
 ; // Predication flags on instruction token
 ; #define D3DSHADER_INSTRUCTION_PREDICATED    (0x1 << 28)
 ; 
 ; //---------------------------------------------------------------------
 ; // DCL Info Token Controls
 ; 
 ; // For dcl info tokens requiring a semantic (usage + index)
 ; #define D3DSP_DCL_USAGE_SHIFT 0
 ; #define D3DSP_DCL_USAGE_MASK  0x0000000f
 ; 
 ; #define D3DSP_DCL_USAGEINDEX_SHIFT 16
 ; #define D3DSP_DCL_USAGEINDEX_MASK  0x000f0000
 ; 
 ; // DCL pixel shader sampler info token.
 ; #define D3DSP_TEXTURETYPE_SHIFT 27
 ; #define D3DSP_TEXTURETYPE_MASK  0x78000000
 ; 
 ; typedef enum _D3DSAMPLER_TEXTURE_TYPE
 ; {
 ;     D3DSTT_UNKNOWN = 0<<D3DSP_TEXTURETYPE_SHIFT, // uninitialized value
 ;     D3DSTT_2D      = 2<<D3DSP_TEXTURETYPE_SHIFT, // dcl_2d s# (for declaring a 2-D texture)
 ;     D3DSTT_CUBE    = 3<<D3DSP_TEXTURETYPE_SHIFT, // dcl_cube s# (for declaring a cube texture)
 ;     D3DSTT_VOLUME  = 4<<D3DSP_TEXTURETYPE_SHIFT, // dcl_volume s# (for declaring a volume texture)
 ;     D3DSTT_FORCE_DWORD  = 0x7fffffff,      // force 32-bit size enum
 ; } D3DSAMPLER_TEXTURE_TYPE;
 ; 
 ; //---------------------------------------------------------------------
 ; // Parameter Token Bit Definitions
 ; //
 ; #define D3DSP_REGNUM_MASK       0x000007FF
 ; 
 ; // destination parameter write mask
 ; #define D3DSP_WRITEMASK_0       0x00010000  // Component 0 (X;Red)
 ; #define D3DSP_WRITEMASK_1       0x00020000  // Component 1 (Y;Green)
 ; #define D3DSP_WRITEMASK_2       0x00040000  // Component 2 (Z;Blue)
 ; #define D3DSP_WRITEMASK_3       0x00080000  // Component 3 (W;Alpha)
 ; #define D3DSP_WRITEMASK_ALL     0x000F0000  // All Components
 ; 
 ; // destination parameter modifiers
 ; #define D3DSP_DSTMOD_SHIFT      20
 ; #define D3DSP_DSTMOD_MASK       0x00F00000
 ; 
 ; // Bit masks for destination parameter modifiers
 ; #define    D3DSPDM_NONE                 (0<<D3DSP_DSTMOD_SHIFT) // nop
 ; #define    D3DSPDM_SATURATE             (1<<D3DSP_DSTMOD_SHIFT) // clamp to 0. to 1. range
 ; #define    D3DSPDM_PARTIALPRECISION     (2<<D3DSP_DSTMOD_SHIFT) // Partial precision hint
 ; #define    D3DSPDM_MSAMPCENTROID        (4<<D3DSP_DSTMOD_SHIFT) // Relevant to multisampling only:
 ;                                                                 //      When the pixel center is not covered, sample
 ;                                                                 //      attribute or compute gradients/LOD
 ;                                                                 //      using multisample "centroid" location.
 ;                                                                 //      "Centroid" is some location within the covered
 ;                                                                 //      region of the pixel.
 ; 
 ; // destination parameter 
 ; #define D3DSP_DSTSHIFT_SHIFT    24
 ; #define D3DSP_DSTSHIFT_MASK     0x0F000000
 ; 
 ; // destination/source parameter register type
 ; #define D3DSP_REGTYPE_SHIFT     28
 ; #define D3DSP_REGTYPE_SHIFT2    8
 ; #define D3DSP_REGTYPE_MASK      0x70000000
 ; #define D3DSP_REGTYPE_MASK2     0x00001800
 ; 
 ; typedef enum _D3DSHADER_PARAM_REGISTER_TYPE
 ; {
 ;     D3DSPR_TEMP           =  0, // Temporary Register File
 ;     D3DSPR_INPUT          =  1, // Input Register File
 ;     D3DSPR_CONST          =  2, // Constant Register File
 ;     D3DSPR_ADDR           =  3, // Address Register (VS)
 ;     D3DSPR_TEXTURE        =  3, // Texture Register File (PS)
 ;     D3DSPR_RASTOUT        =  4, // Rasterizer Register File
 ;     D3DSPR_ATTROUT        =  5, // Attribute Output Register File
 ;     D3DSPR_TEXCRDOUT      =  6, // Texture Coordinate Output Register File
 ;     D3DSPR_OUTPUT         =  6, // Output register file for VS3.0+
 ;     D3DSPR_CONSTINT       =  7, // Constant Integer Vector Register File
 ;     D3DSPR_COLOROUT       =  8, // Color Output Register File
 ;     D3DSPR_DEPTHOUT       =  9, // Depth Output Register File
 ;     D3DSPR_SAMPLER        = 10, // Sampler State Register File
 ;     D3DSPR_CONST2         = 11, // Constant Register File  2048 - 4095
 ;     D3DSPR_CONST3         = 12, // Constant Register File  4096 - 6143
 ;     D3DSPR_CONST4         = 13, // Constant Register File  6144 - 8191
 ;     D3DSPR_CONSTBOOL      = 14, // Constant Boolean register file
 ;     D3DSPR_LOOP           = 15, // Loop counter register file
 ;     D3DSPR_TEMPFLOAT16    = 16, // 16-bit float temp register file
 ;     D3DSPR_MISCTYPE       = 17, // Miscellaneous (single) registers.
 ;     D3DSPR_LABEL          = 18, // Label
 ;     D3DSPR_PREDICATE      = 19, // Predicate register
 ;     D3DSPR_FORCE_DWORD  = 0x7fffffff,         // force 32-bit size enum
 ; } D3DSHADER_PARAM_REGISTER_TYPE;
 ; 
 ; // The miscellaneous register file (D3DSPR_MISCTYPES)
 ; // contains register types for which there is only ever one
 ; // register (i.e. the register # is not needed).
 ; // Rather than use up additional register types for such
 ; // registers, they are defined
 ; // as particular offsets into the misc. register file:
 ; typedef enum _D3DSHADER_MISCTYPE_OFFSETS
 ; {
 ;     D3DSMO_POSITION   = 0, // Input position x,y,z,rhw (PS)
 ;     D3DSMO_FACE   = 1, // Floating point primitive area (PS)
 ; } D3DSHADER_MISCTYPE_OFFSETS;
 ; 
 ; // Register offsets in the Rasterizer Register File
 ; //
 ; typedef enum _D3DVS_RASTOUT_OFFSETS
 ; {
 ;     D3DSRO_POSITION = 0,
 ;     D3DSRO_FOG,
 ;     D3DSRO_POINT_SIZE,
 ;     D3DSRO_FORCE_DWORD  = 0x7fffffff,         // force 32-bit size enum
 ; } D3DVS_RASTOUT_OFFSETS;
 ; 
 ; // Source operand addressing modes
 ; 
 ; #define D3DVS_ADDRESSMODE_SHIFT 13
 ; #define D3DVS_ADDRESSMODE_MASK  (1 << D3DVS_ADDRESSMODE_SHIFT)
 ; 
 ; typedef enum _D3DVS_ADDRESSMODE_TYPE
 ; {
 ;     D3DVS_ADDRMODE_ABSOLUTE  = (0 << D3DVS_ADDRESSMODE_SHIFT),
 ;     D3DVS_ADDRMODE_RELATIVE  = (1 << D3DVS_ADDRESSMODE_SHIFT),
 ;     D3DVS_ADDRMODE_FORCE_DWORD = 0x7fffffff, // force 32-bit size enum
 ; } D3DVS_ADDRESSMODE_TYPE;
 ; 
 ; #define D3DSHADER_ADDRESSMODE_SHIFT 13
 ; #define D3DSHADER_ADDRESSMODE_MASK  (1 << D3DSHADER_ADDRESSMODE_SHIFT)
 ; 
 ; typedef enum _D3DSHADER_ADDRESSMODE_TYPE
 ; {
 ;     D3DSHADER_ADDRMODE_ABSOLUTE  = (0 << D3DSHADER_ADDRESSMODE_SHIFT),
 ;     D3DSHADER_ADDRMODE_RELATIVE  = (1 << D3DSHADER_ADDRESSMODE_SHIFT),
 ;     D3DSHADER_ADDRMODE_FORCE_DWORD = 0x7fffffff, // force 32-bit size enum
 ; } D3DSHADER_ADDRESSMODE_TYPE;
 ; 
 ; // Source operand swizzle definitions
 ; //
 ; #define D3DVS_SWIZZLE_SHIFT     16
 ; #define D3DVS_SWIZZLE_MASK      0x00FF0000
 ; 
 ; // The following bits define where to take component X from:
 ; 
 ; #define D3DVS_X_X       (0 << D3DVS_SWIZZLE_SHIFT)
 ; #define D3DVS_X_Y       (1 << D3DVS_SWIZZLE_SHIFT)
 ; #define D3DVS_X_Z       (2 << D3DVS_SWIZZLE_SHIFT)
 ; #define D3DVS_X_W       (3 << D3DVS_SWIZZLE_SHIFT)
 ; 
 ; // The following bits define where to take component Y from:
 ; 
 ; #define D3DVS_Y_X       (0 << (D3DVS_SWIZZLE_SHIFT + 2))
 ; #define D3DVS_Y_Y       (1 << (D3DVS_SWIZZLE_SHIFT + 2))
 ; #define D3DVS_Y_Z       (2 << (D3DVS_SWIZZLE_SHIFT + 2))
 ; #define D3DVS_Y_W       (3 << (D3DVS_SWIZZLE_SHIFT + 2))
 ; 
 ; // The following bits define where to take component Z from:
 ; 
 ; #define D3DVS_Z_X       (0 << (D3DVS_SWIZZLE_SHIFT + 4))
 ; #define D3DVS_Z_Y       (1 << (D3DVS_SWIZZLE_SHIFT + 4))
 ; #define D3DVS_Z_Z       (2 << (D3DVS_SWIZZLE_SHIFT + 4))
 ; #define D3DVS_Z_W       (3 << (D3DVS_SWIZZLE_SHIFT + 4))
 ; 
 ; // The following bits define where to take component W from:
 ; 
 ; #define D3DVS_W_X       (0 << (D3DVS_SWIZZLE_SHIFT + 6))
 ; #define D3DVS_W_Y       (1 << (D3DVS_SWIZZLE_SHIFT + 6))
 ; #define D3DVS_W_Z       (2 << (D3DVS_SWIZZLE_SHIFT + 6))
 ; #define D3DVS_W_W       (3 << (D3DVS_SWIZZLE_SHIFT + 6))
 ; 
 ; // Value when there is no swizzle (X is taken from X, Y is taken from Y,
 ; // Z is taken from Z, W is taken from W
 ; //
 ; #define D3DVS_NOSWIZZLE (D3DVS_X_X | D3DVS_Y_Y | D3DVS_Z_Z | D3DVS_W_W)
 ; 
 ; // source parameter swizzle
 ; #define D3DSP_SWIZZLE_SHIFT     16
 ; #define D3DSP_SWIZZLE_MASK      0x00FF0000
 ; 
 ; #define D3DSP_NOSWIZZLE \
 ;     ( (0 << (D3DSP_SWIZZLE_SHIFT + 0)) | \
 ;       (1 << (D3DSP_SWIZZLE_SHIFT + 2)) | \
 ;       (2 << (D3DSP_SWIZZLE_SHIFT + 4)) | \
 ;       (3 << (D3DSP_SWIZZLE_SHIFT + 6)) )
 ; 
 ; // pixel-shader swizzle ops
 ; #define D3DSP_REPLICATERED \
 ;     ( (0 << (D3DSP_SWIZZLE_SHIFT + 0)) | \
 ;       (0 << (D3DSP_SWIZZLE_SHIFT + 2)) | \
 ;       (0 << (D3DSP_SWIZZLE_SHIFT + 4)) | \
 ;       (0 << (D3DSP_SWIZZLE_SHIFT + 6)) )
 ; 
 ; #define D3DSP_REPLICATEGREEN \
 ;     ( (1 << (D3DSP_SWIZZLE_SHIFT + 0)) | \
 ;       (1 << (D3DSP_SWIZZLE_SHIFT + 2)) | \
 ;       (1 << (D3DSP_SWIZZLE_SHIFT + 4)) | \
 ;       (1 << (D3DSP_SWIZZLE_SHIFT + 6)) )
 ; 
 ; #define D3DSP_REPLICATEBLUE \
 ;     ( (2 << (D3DSP_SWIZZLE_SHIFT + 0)) | \
 ;       (2 << (D3DSP_SWIZZLE_SHIFT + 2)) | \
 ;       (2 << (D3DSP_SWIZZLE_SHIFT + 4)) | \
 ;       (2 << (D3DSP_SWIZZLE_SHIFT + 6)) )
 ; 
 ; #define D3DSP_REPLICATEALPHA \
 ;     ( (3 << (D3DSP_SWIZZLE_SHIFT + 0)) | \
 ;       (3 << (D3DSP_SWIZZLE_SHIFT + 2)) | \
 ;       (3 << (D3DSP_SWIZZLE_SHIFT + 4)) | \
 ;       (3 << (D3DSP_SWIZZLE_SHIFT + 6)) )
 ; 
 ; // source parameter modifiers
 ; #define D3DSP_SRCMOD_SHIFT      24
 ; #define D3DSP_SRCMOD_MASK       0x0F000000
 ; 
 ; typedef enum _D3DSHADER_PARAM_SRCMOD_TYPE
 ; {
 ;     D3DSPSM_NONE    = 0<<D3DSP_SRCMOD_SHIFT, // nop
 ;     D3DSPSM_NEG     = 1<<D3DSP_SRCMOD_SHIFT, // negate
 ;     D3DSPSM_BIAS    = 2<<D3DSP_SRCMOD_SHIFT, // bias
 ;     D3DSPSM_BIASNEG = 3<<D3DSP_SRCMOD_SHIFT, // bias and negate
 ;     D3DSPSM_SIGN    = 4<<D3DSP_SRCMOD_SHIFT, // sign
 ;     D3DSPSM_SIGNNEG = 5<<D3DSP_SRCMOD_SHIFT, // sign and negate
 ;     D3DSPSM_COMP    = 6<<D3DSP_SRCMOD_SHIFT, // complement
 ;     D3DSPSM_X2      = 7<<D3DSP_SRCMOD_SHIFT, // *2
 ;     D3DSPSM_X2NEG   = 8<<D3DSP_SRCMOD_SHIFT, // *2 and negate
 ;     D3DSPSM_DZ      = 9<<D3DSP_SRCMOD_SHIFT, // divide through by z component
 ;     D3DSPSM_DW      = 10<<D3DSP_SRCMOD_SHIFT, // divide through by w component
 ;     D3DSPSM_ABS     = 11<<D3DSP_SRCMOD_SHIFT, // abs()
 ;     D3DSPSM_ABSNEG  = 12<<D3DSP_SRCMOD_SHIFT, // -abs()
 ;     D3DSPSM_NOT     = 13<<D3DSP_SRCMOD_SHIFT, // for predicate register: "!p0"
 ;     D3DSPSM_FORCE_DWORD = 0x7fffffff,        // force 32-bit size enum
 ; } D3DSHADER_PARAM_SRCMOD_TYPE;
 ; 
 ; // pixel shader version token
 ; #define D3DPS_VERSION(_Major,_Minor) (0xFFFF0000|((_Major)<<8)|(_Minor))
 ; 
 ; // vertex shader version token
 ; #define D3DVS_VERSION(_Major,_Minor) (0xFFFE0000|((_Major)<<8)|(_Minor))
 ; 
 ; // extract major/minor from version cap
 ; #define D3DSHADER_VERSION_MAJOR(_Version) (((_Version)>>8)&0xFF)
 ; #define D3DSHADER_VERSION_MINOR(_Version) (((_Version)>>0)&0xFF)
 ; 
 ; // destination/source parameter register type
 ; #define D3DSI_COMMENTSIZE_SHIFT     16
 ; #define D3DSI_COMMENTSIZE_MASK      0x7FFF0000
 ; #define D3DSHADER_COMMENT(_DWordSize) \
 ;     ((((_DWordSize)<<D3DSI_COMMENTSIZE_SHIFT)&D3DSI_COMMENTSIZE_MASK)|D3DSIO_COMMENT)
 ; 
 ; // pixel/vertex shader end token
 ; #define D3DPS_END()  0x0000FFFF
 ; #define D3DVS_END()  0x0000FFFF
 ; 
 ; 
;//---------------------------------------------------------------------
;// High order surfaces
;//
   D3DBASIS_BEZIER      equ 0
   D3DBASIS_BSPLINE     equ 1
   D3DBASIS_CATMULL_ROM equ 2; /* In D3D8 this used to be D3DBASIS_INTERPOLATE */
   D3DBASIS_FORCE_DWORD equ 07fffffffh

   D3DDEGREE_LINEAR      equ 1
   D3DDEGREE_QUADRATIC   equ 2
   D3DDEGREE_CUBIC       equ 3
   D3DDEGREE_QUINTIC     equ 5
   D3DDEGREE_FORCE_DWORD equ 7fffffffh

   D3DPATCHEDGE_DISCRETE   equ 0

   D3DPATCHEDGE_CONTINUOUS  equ 1
   D3DPATCHEDGE_FORCE_DWORD equ 7fffffffh

    D3DSBT_ALL           equ 1; // capture all state
    D3DSBT_PIXELSTATE    equ 2; // capture pixel state
    D3DSBT_VERTEXSTATE   equ 3; // capture vertex state
    D3DSBT_FORCE_DWORD   equ 07fffffffh

;// The D3DVERTEXBLENDFLAGS type is used with D3DRS_VERTEXBLEND state.
;//
    D3DVBF_DISABLE  equ 0;     // Disable vertex blending
    D3DVBF_1WEIGHTS equ 1;     // 2 matrix blending
    D3DVBF_2WEIGHTS equ 2;     // 3 matrix blending
    D3DVBF_3WEIGHTS equ 3;     // 4 matrix blending
    D3DVBF_TWEENING equ 255;   // blending using D3DRS_TWEENFACTOR
    D3DVBF_0WEIGHTS equ 256;   // one matrix is used with weight 1.0
    D3DVBF_FORCE_DWORD equ  07fffffffh; // force 32-bit size enum

    D3DTTFF_DISABLE         equ 0;    // texture coordinates are passed directly
    D3DTTFF_COUNT1          equ 1;    // rasterizer should expect 1-D texture coords
    D3DTTFF_COUNT2          equ 2;    // rasterizer should expect 2-D texture coords
    D3DTTFF_COUNT3          equ 3;    // rasterizer should expect 3-D texture coords
    D3DTTFF_COUNT4          equ 4;    // rasterizer should expect 4-D texture coords
    D3DTTFF_PROJECTED       equ 256;  // texcoords to be divided by COUNTth element
    D3DTTFF_FORCE_DWORD     equ 07fffffffh

;// Macros to set texture coordinate format bits in the FVF id

D3DFVF_TEXTUREFORMAT2 equ 0        ; // Two floating point values
D3DFVF_TEXTUREFORMAT1 equ 3        ; // One floating point value
D3DFVF_TEXTUREFORMAT3 equ 1        ; // Three floating point values
D3DFVF_TEXTUREFORMAT4 equ 2        ; // Four floating point values

;D3DFVF_TEXCOORDSIZE3(CoordIndex) (D3DFVF_TEXTUREFORMAT3 << (CoordIndex*2 + 16))
;D3DFVF_TEXCOORDSIZE2(CoordIndex) (D3DFVF_TEXTUREFORMAT2)
;D3DFVF_TEXCOORDSIZE4(CoordIndex) (D3DFVF_TEXTUREFORMAT4 << (CoordIndex*2 + 16))
;D3DFVF_TEXCOORDSIZE1(CoordIndex) (D3DFVF_TEXTUREFORMAT1 << (CoordIndex*2 + 16))


;//---------------------------------------------------------------------

;/* Direct3D9 Device types */
    D3DDEVTYPE_HAL         equ 1
    D3DDEVTYPE_REF         equ 2
    D3DDEVTYPE_SW          equ 3
    D3DDEVTYPE_FORCE_DWORD  equ 7fffffffh

;/* Multi-Sample buffer types */
    D3DMULTISAMPLE_NONE            equ 0
    D3DMULTISAMPLE_NONMASKABLE     equ 1
    D3DMULTISAMPLE_2_SAMPLES       equ 2
    D3DMULTISAMPLE_3_SAMPLES       equ 3
    D3DMULTISAMPLE_4_SAMPLES       equ 4
    D3DMULTISAMPLE_5_SAMPLES       equ 5
    D3DMULTISAMPLE_6_SAMPLES       equ 6
    D3DMULTISAMPLE_7_SAMPLES       equ 7
    D3DMULTISAMPLE_8_SAMPLES       equ 8
    D3DMULTISAMPLE_9_SAMPLES       equ 9
    D3DMULTISAMPLE_10_SAMPLES      equ 10
    D3DMULTISAMPLE_11_SAMPLES      equ 11
    D3DMULTISAMPLE_12_SAMPLES      equ 12
    D3DMULTISAMPLE_13_SAMPLES      equ 13
    D3DMULTISAMPLE_14_SAMPLES      equ 14
    D3DMULTISAMPLE_15_SAMPLES      equ 15
    D3DMULTISAMPLE_16_SAMPLES      equ 16
    D3DMULTISAMPLE_FORCE_DWORD    equ 7fffffffh

;/* Formats
 ;  * Most of these names have the following convention:
 ;  *      A = Alpha
 ;  *      R = Red
 ;  *      G = Green
 ;  *      B = Blue
 ;  *      X = Unused Bits
 ;  *      P = Palette
 ;  *      L = Luminance
 ;  *      U = dU coordinate for BumpMap
 ;  *      V = dV coordinate for BumpMap
 ;  *      S = Stencil
 ;  *      D = Depth (e.g. Z or W buffer)
 ;  *      C = Computed from other channels (typically on certain read operations)
 ;  *
 ;  *      Further, the order of the pieces are from MSB first; hence
 ;  *      D3DFMT_A8L8 indicates that the high byte of this two byte
 ;  *      format is alpha.
 ;  *
 ;  *      D16 indicates:
 ;  *           - An integer 16-bit value.
 ;  *           - An app-lockable surface.
 ;  *
 ;  *      All Depth/Stencil formats except D3DFMT_D16_LOCKABLE indicate:
 ;  *          - no particular bit ordering per pixel, and
 ;  *          - are not app lockable, and
 ;  *          - the driver is allowed to consume more than the indicated
 ;  *            number of bits per Depth channel (but not Stencil channel).
 ;  */
 ; 
MAKEFOURCC MACRO ch0, ch1, ch2, ch3
	LOCAL DefineAs
	DefineAs TEXTEQU %((DWORD)(BYTE)(ch0)  OR  ((DWORD)(BYTE)(ch1)  SHL  8)  OR        \
                ((DWORD)(BYTE)(ch2)  SHL  16)  OR  ((DWORD)(BYTE)(ch3)  SHL  24 ))
	EXITM DefineAs
ENDM MAKEFOURCC

    D3DFMT_UNKNOWN              EQU  0
    D3DFMT_R8G8B8               EQU 20
    D3DFMT_A8R8G8B8             EQU 21
    D3DFMT_X8R8G8B8             EQU 22
    D3DFMT_R5G6B5               EQU 23
    D3DFMT_X1R5G5B5             EQU 24
    D3DFMT_A1R5G5B5             EQU 25
    D3DFMT_A4R4G4B4             EQU 26
    D3DFMT_R3G3B2               EQU 27
    D3DFMT_A8                   EQU 28
    D3DFMT_A8R3G3B2             EQU 29
    D3DFMT_X4R4G4B4             EQU 30


    D3DFMT_A2B10G10R10          EQU 31
    D3DFMT_A8B8G8R8             EQU 32
    D3DFMT_X8B8G8R8             EQU 33
    D3DFMT_G16R16               EQU 34
    D3DFMT_A2R10G10B10          EQU 35
    D3DFMT_A16B16G16R16         EQU 36

    D3DFMT_A8P8                 EQU 40
    D3DFMT_P8                   EQU 41

    D3DFMT_L8                   EQU 50
    D3DFMT_A8L8                 EQU 51
    D3DFMT_A4L4                 EQU 52

    D3DFMT_V8U8                 EQU 60
    D3DFMT_L6V5U5               EQU 61
    D3DFMT_X8L8V8U8             EQU 62
    D3DFMT_Q8W8V8U8             EQU 63
    D3DFMT_V16U16               EQU 64
    D3DFMT_A2W10V10U10          EQU 67

    D3DFMT_UYVY                 EQU MAKEFOURCC 'U', 'Y', 'V', 'Y'
    D3DFMT_R8G8_B8G8      EQU MAKEFOURCC 'R', 'G', 'B', 'G'
    D3DFMT_YUY2                 EQU MAKEFOURCC 'Y', 'U', 'Y', '2'
    D3DFMT_G8R8_G8B8    EQU  MAKEFOURCC 'G', 'R', 'G', 'B'
    D3DFMT_DXT1           EQU  MAKEFOURCC 'D', 'X', 'T', '1'
    D3DFMT_DXT2         EQU  MAKEFOURCC 'D', 'X', 'T', '2'
    D3DFMT_DXT3        EQU  MAKEFOURCC 'D', 'X', 'T', '3'
    D3DFMT_DXT4       EQU MAKEFOURCC 'D', 'X', 'T', '4'
    D3DFMT_DXT5      EQU  MAKEFOURCC 'D', 'X', 'T', '5'

    D3DFMT_D16_LOCKABLE         EQU 70
    D3DFMT_D32                  EQU 71
    D3DFMT_D15S1                EQU 73
    D3DFMT_D24S8                EQU 75
    D3DFMT_D24X8                EQU 77
    D3DFMT_D24X4S4              EQU 79
    D3DFMT_D16                  EQU 80

    D3DFMT_D32F_LOCKABLE        EQU 82
    D3DFMT_D24FS8               EQU 83

    D3DFMT_L16                  EQU 81

    D3DFMT_VERTEXDATA           EQU 100
    D3DFMT_INDEX16              EQU 101
    D3DFMT_INDEX32              EQU 102

    D3DFMT_Q16W16V16U16         EQU 110

    D3DFMT_MULTI2_ARGB8         EQU  MAKEFOURCC 'M','E','T','1'

  ;  // Floating point surface formats

  ;  // s10e5 formats (16-bits per channel)
    D3DFMT_R16F                 EQU 111
    D3DFMT_G16R16F              EQU 112
    D3DFMT_A16B16G16R16F        EQU 113

  ;  // IEEE s23e8 formats (32-bits per channel)
    D3DFMT_R32F                 EQU 114
    D3DFMT_G32R32F              EQU 115
    D3DFMT_A32B32G32R32F        EQU 116

    D3DFMT_CxV8U8               EQU 117
    D3DFMT_FORCE_DWORD         EQU 7fffffffh

D3DFORMAT typedef DWORD
D3DDEVTYPE typedef DWORD

;/* Display Modes */
D3DDISPLAYMODE struct
    _Width dd ?
    Height dd ?
    RefreshRate dd ?
    Format D3DFORMAT ?
D3DDISPLAYMODE ends

;/* Creation Parameters */
D3DDEVICE_CREATION_PARAMETERS struct
    AdapterOrdinal dd ?
    DeviceType D3DDEVTYPE ?
    hFocusWindow dd ?
    BehaviorFlags dd ?
D3DDEVICE_CREATION_PARAMETERS ends

;/* SwapEffects */
    D3DSWAPEFFECT_DISCARD           equ 1
    D3DSWAPEFFECT_FLIP              equ 2
    D3DSWAPEFFECT_COPY              equ 3
    D3DSWAPEFFECT_FORCE_DWORD     equ 7fffffffh

;/* Pool types */
    D3DPOOL_DEFAULT                 equ 0
    D3DPOOL_MANAGED                 equ 1
    D3DPOOL_SYSTEMMEM               equ 2
    D3DPOOL_SCRATCH                 equ 3
    D3DPOOL_FORCE_DWORD             equ 07fffffffh

;/* RefreshRate pre-defines */
D3DPRESENT_RATE_DEFAULT    equ 0

;/* Resize Optional Parameters */
D3DPRESENT_PARAMETERS struct
    BackBufferWidth dd ?
    BackBufferHeight dd ?
    BackBufferFormat D3DFORMAT ?
    BackBufferCount dd ?
    MultiSampleType dd ?
    MultiSampleQuality dd ?
    SwapEffect dd ?
    hDeviceWindow dd ?
    Windowed BOOL ?
    EnableAutoDepthStencil BOOL ?
    AutoDepthStencilFormat D3DFORMAT ?
    Flags dd ?
;    /* FullScreen_RefreshRateInHz must be zero for Windowed mode */
    FullScreen_RefreshRateInHz dd ?
    PresentationInterval dd ?
D3DPRESENT_PARAMETERS ends

;// Values for D3DPRESENT_PARAMETERS.Flags

D3DPRESENTFLAG_LOCKABLE_BACKBUFFER      equ 1
D3DPRESENTFLAG_DISCARD_DEPTHSTENCIL     equ 2
D3DPRESENTFLAG_DEVICECLIP               equ 4
D3DPRESENTFLAG_VIDEO                    equ 16

;/* Gamma Ramp: Same as DX7 */
D3DGAMMARAMP struct
    red dw 256 dup (?)
    green dw 256 dup (?)
    blue dw 256 dup (?)
D3DGAMMARAMP ends

;/* Back buffer types */
    D3DBACKBUFFER_TYPE_MONO         equ 0
    D3DBACKBUFFER_TYPE_LEFT         equ 1
    D3DBACKBUFFER_TYPE_RIGHT        equ 2
    D3DBACKBUFFER_TYPE_FORCE_DWORD  equ 7fffffffh

;/* Types */
    D3DRTYPE_SURFACE                equ 1

    D3DRTYPE_VOLUME                 equ 2
    D3DRTYPE_TEXTURE                equ 3
    D3DRTYPE_VOLUMETEXTURE          equ 4
    D3DRTYPE_CUBETEXTURE            equ 5
    D3DRTYPE_VERTEXBUFFER           equ 6
    D3DRTYPE_INDEXBUFFER            equ 7
    D3DRTYPE_FORCE_DWORD            equ 07fffffffh

;/* Usages */
D3DUSAGE_RENDERTARGET    equ 1
D3DUSAGE_DEPTHSTENCIL    equ 2
D3DUSAGE_DYNAMIC          equ  00000200h

;// When passed to CheckDeviceFormat, D3DUSAGE_AUTOGENMIPMAP may return
;// D3DOK_NOAUTOGEN if the device doesn't support autogeneration for that format.
;// D3DOK_NOAUTOGEN is a success code, not a failure code... the SUCCEEDED and FAILED macros
;// will return true and false respectively for this code.
D3DUSAGE_AUTOGENMIPMAP equ 00000400h
D3DUSAGE_DMAP     equ 00004000h

;// The following usages are valid only for querying CheckDeviceFormat
D3DUSAGE_QUERY_LEGACYBUMPMAP  equ 00008000h
D3DUSAGE_QUERY_SRGBREAD    equ 00010000L)
D3DUSAGE_QUERY_FILTER         equ 00020000h
D3DUSAGE_QUERY_SRGBWRITE      equ 00040000h
D3DUSAGE_QUERY_POSTPIXELSHADER_BLENDING equ 00080000h
D3DUSAGE_QUERY_VERTEXTEXTURE        equ 00100000h

;/* Usages for Vertex/Index buffers */
D3DUSAGE_WRITEONLY          equ 00000008h
D3DUSAGE_SOFTWAREPROCESSING equ 00000010h
D3DUSAGE_DONOTCLIP          equ 00000020h
D3DUSAGE_POINTS             equ 00000040h
D3DUSAGE_RTPATCHES          equ 00000080h
D3DUSAGE_NPATCHES           equ 00000100h

;/* CubeMap Face identifiers */
    D3DCUBEMAP_FACE_POSITIVE_X     equ 0
    D3DCUBEMAP_FACE_NEGATIVE_X     equ 1
    D3DCUBEMAP_FACE_POSITIVE_Y     equ 2
    D3DCUBEMAP_FACE_NEGATIVE_Y     equ 3
    D3DCUBEMAP_FACE_POSITIVE_Z     equ 4
    D3DCUBEMAP_FACE_NEGATIVE_Z     equ 5
    D3DCUBEMAP_FACE_FORCE_DWORD    equ 7fffffffh

;/* Lock flags */
D3DLOCK_READONLY           equ 00000010h
D3DLOCK_DISCARD           equ 00002000h
D3DLOCK_NOOVERWRITE  equ 00001000h
D3DLOCK_NOSYSLOCK   equ 00000800h
D3DLOCK_DONOTWAIT   equ 00004000h                  
D3DLOCK_NO_DIRTY_UPDATE   equ 00008000h

D3DRESOURCETYPE  typedef DWORD
D3DPOOL typedef DWORD

;/* Vertex Buffer Description */
D3DVERTEXBUFFER_DESC struct
    Format D3DFORMAT ?
    _Type D3DRESOURCETYPE  ?
    Usage DWORD ?
    Pool D3DPOOL  ?
    _Size DWORD ?
    FVF DWORD ?
D3DVERTEXBUFFER_DESC ends

;/* Index Buffer Description */
D3DINDEXBUFFER_DESC struct
    Format D3DFORMAT ?
    _Type D3DRESOURCETYPE  ?
    Usage DWORD ?
    Pool D3DPOOL  ?
    _Size DWORD ?
D3DINDEXBUFFER_DESC ends

D3DMULTISAMPLE_TYPE typedef DWORD

;/* Surface Description */
D3DSURFACE_DESC struct
    Format D3DFORMAT ?
    _Type D3DRESOURCETYPE  ?
    Usage DWORD ?
    Pool D3DPOOL  ?
    MultiSampleType D3DMULTISAMPLE_TYPE ?
    MultiSampleQuality dd ?
    _Width dd ?
    Height dd ?
D3DSURFACE_DESC ends

D3DVOLUME_DESC struct
    Format D3DFORMAT ?
    _Type D3DRESOURCETYPE  ?
    Usage DWORD ?
    Pool D3DPOOL  ?
    _Width dd ?
    Height dd ?
    Depth dd ?
D3DVOLUME_DESC ends

;/* Structure for LockRect */
D3DLOCKED_RECT struct
    Pitch dd ?
    pBits dd ?
D3DLOCKED_RECT ends

;/* Structures for LockBox */
D3DBOX struct
    Left dd ?
    Top dd ?
    Right dd ?
    Bottom dd ?
    Front dd ?
    Back dd ?
D3DBOX ends

D3DLOCKED_BOX struct
    RowPitch dd ?
    SlicePitch dd ?
    pBits dd ?
D3DLOCKED_BOX ends

;/* Structures for LockRange */
D3DRANGE struct
_Offset dd ?
_Size dd ?
D3DRANGE ends

;/* Structures for high order primitives */
D3DRECTPATCH_INFO struct
    StartVertexOffsetWidth dd ?
    StartVertexOffsetHeight dd ?
    _Width dd ?
    Height dd ?
    Stride dd ?
    Basis dd        ?
    Degree dd       ?
D3DRECTPATCH_INFO ends

D3DTRIPATCH_INFO struct
    StartVertexOffset dd ?
    NumVertices dd ?
    Basis  dd        ?
    Degree dd       ?
D3DTRIPATCH_INFO ends

;/* Adapter Identifier */
MAX_DEVICE_IDENTIFIER_STRING   equ     512
D3DADAPTER_IDENTIFIER9 struct
    Driver db MAX_DEVICE_IDENTIFIER_STRING dup (?)
    Description db MAX_DEVICE_IDENTIFIER_STRING dup (?)
    DeviceName db 32 dup (?)    ;         /* Device name for GDI (ex. \\.\DISPLAY1) */
    DriverVersionLowPart dd ?;   /* Defined for 16 bit driver components */
    DriverVersionHighPart dd ?;
    VendorId dd ?
    DeviceId dd ?
    SubSysId dd ?
    Revision dd ?
    DeviceIdentifier GUID <?>
    WHQLLevel dd ?
D3DADAPTER_IDENTIFIER9 ends

;/* Raster Status structure returned by GetRasterStatus */
D3DRASTER_STATUS struct
    InVBlank dd ?
    ScanLine dd ?
D3DRASTER_STATUS ends

;/* Debug monitor tokens (DEBUG only)

 ;  Note that if D3DRS_DEBUGMONITORTOKEN is set, the call is treated as
 ;  passing a token to the debug monitor.  For example, if, after passing
 ;  D3DDMT_ENABLE/DISABLE to D3DRS_DEBUGMONITORTOKEN other token values
 ;  are passed in, the enabled/disabled state of the debug
 ;  monitor will still persist.

;   The debug monitor defaults to enabled.

 ;  Calling GetRenderState on D3DRS_DEBUGMONITORTOKEN is not of any use.
;*/
    D3DDMT_ENABLE   equ 0;    // enable debug monitor
    D3DDMT_DISABLE  equ 1;    // disable debug monitor
    D3DDMT_FORCE_DWORD   equ 7fffffffh

;// Async feedback

    D3DQUERYTYPE_VCACHE   equ 4; /* D3DISSUE_END */
    D3DQUERYTYPE_RESOURCEMANAGER   equ  5; /* D3DISSUE_END */
    D3DQUERYTYPE_VERTEXSTATS  equ  6; /* D3DISSUE_END */
    D3DQUERYTYPE_EVENT    equ  8; /* D3DISSUE_END */
    D3DQUERYTYPE_OCCLUSION    equ  9; /* D3DISSUE_BEGIN, D3DISSUE_END */

;// Flags field for Issue
D3DISSUE_END equ 1;// Tells the runtime to issue the end of a query, changing it's state to "non-signaled".
D3DISSUE_BEGIN equ 2; // Tells the runtime to issue the beginng of a query.

;// Flags field for GetData
D3DGETDATA_FLUSH equ 1; // Tells the runtime to flush if the query is outstanding.

D3DRESOURCESTATS struct
;// Data collected since last Present()
    bThrashing dd ?;             /* indicates if thrashing */
    ApproxBytesDownloaded dd ?;  /* Approximate number of bytes downloaded by resource manager */
    NumEvicts dd ?;              /* number of objects evicted */
    NumVidCreates dd ?;          /* number of objects created in video memory */
    LastPri dd ?;                /* priority of last object evicted */
    NumUsed dd ?;                /* number of objects set to the device */
    NumUsedInVidMem dd ?;        /* number of objects set to the device, which are already in video memory */
;// Persistent data
    WorkingSet dd ?;             /* number of objects in video memory */
    WorkingSetBytes dd ?;        /* number of bytes in video memory */
    TotalManaged dd ?;           /* total number of managed objects */
    TotalBytes dd ?;             /* total number of bytes of managed objects */
D3DRESOURCESTATS ends

D3DRTYPECOUNT equ D3DRTYPE_INDEXBUFFER+1

D3DDEVINFO_RESOURCEMANAGER struct
    stats D3DRESOURCESTATS D3DRTYPECOUNT dup (<?>)
D3DDEVINFO_RESOURCEMANAGER ends
LPD3DDEVINFO_RESOURCEMANAGER typedef ptr D3DDEVINFO_RESOURCEMANAGER

D3DDEVINFO_D3DVERTEXSTATS struct
    NumRenderedTriangles dd ?;       /* total number of triangles that are not clipped in this frame */
    NumExtraClippingTriangles dd ?;  /* Number of new triangles generated by clipping */
D3DDEVINFO_D3DVERTEXSTATS ends
LPD3DDEVINFO_D3DVERTEXSTATS typedef ptr D3DDEVINFO_D3DVERTEXSTATS

D3DDEVINFO_VCACHE struct
    Pattern dd ?;                    /* bit pattern, return value must be FOUR_CC(C, A, C, H) */
    OptMethod dd ?;                  /* optimization method 0 means longest strips, 1 means vertex cache based */
    CacheSize dd ?;                  /* cache size to optimize for  (only required if type is 1) */
    MagicNumber dd ?;                /* used to determine when to restart strips (only required if type is 1)*/
D3DDEVINFO_VCACHE ends
LPD3DDEVINFO_VCACHE typedef ptr D3DDEVINFO_VCACHE

endif 

