.686
.xmm
.model flat, stdcall
option casemap:none

;********************************************************************
;**************** includes
;********************************************************************
include     \masm32\include\windows.inc
include     \masm32\include\macros.inc

include     \masm32\include\kernel32.inc
includelib  \masm32\lib\kernel32.lib
include     \masm32\include\user32.inc
includelib  \masm32\lib\user32.lib

includelib  \masm32\lib\d3d9.lib
includelib  \masm32\lib\d3dx9.lib
;includelib  \masm32\lib\uuid.lib
includelib  \masm32\lib\winmm.lib
includelib  \masm32\lib\msvcrt.lib
includelib  \masm32\lib\advapi32.lib
includelib  \masm32\lib\gdi32.lib

include class31.inc                         ;<-- ATC (oop support and other helper macros)
include include\d3d9_homer.inc              ;<-- Main    D3D9 include
include include\d3d9types.inc               ;      (General TypeDefs, Protos, Equates etc)
include include\d3dx9tex.inc                ;      (as above, but Texture-specific)
;include deltawing.inc                      ; my code
;include rotate.inc
;********************************************************************
;**************** /includes
;********************************************************************



;********************************************************************
;**************** Prototypes
;********************************************************************
WinMain proto
RegisterWinClass proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
WndProc proto :DWORD, :DWORD, :DWORD, :DWORD
InitD3D proto :DWORD
InitGeometry proto
Render proto
Cleanup proto

;********************************************************************
;**************** /Prototypes
;********************************************************************


;********************************************************************
;**************** Equates
;********************************************************************

    ;================================================================
    ;============ General Equates
    ;================================================================
    D3D_OK                  equ S_OK
    FAILED                  equ 1
    D3D_SDK_VERSION         equ 31
    ;================================================================
    ;============ /General Equates
    ;================================================================


    ;================================================================
    ;============ Vertex Buffer layout 
    ;================================================================
CUSTOMVERTEX    struct  DWORD
        x       FLOAT   ?
        y       FLOAT   ? 
        z       FLOAT   ?
        rhw     FLOAT   ?   ; The transformed position for the vertex
        tu      FLOAT   ?   ; The horizontal texture coordinate
        tv      FLOAT   ?   ; The vertical texture coordinate
    CUSTOMVERTEX    ENDS
    D3DFVF_CUSTOMVERTEX EQU (D3DFVF_XYZRHW OR D3DFVF_TEX1)



    ;CUSTOMVERTEX    struct  DWORD
    ;    x       FLOAT   ?
    ;    y       FLOAT   ? 
    ;    z       FLOAT   ?
    ;    rhw     FLOAT   ?   ; The transformed position for the vertex
    ;    colour  DWORD   ?   ; The vertex color
    ;CUSTOMVERTEX    ENDS
    ;D3DFVF_CUSTOMVERTEX EQU (D3DFVF_XYZRHW OR D3DFVF_DIFFUSE)
    ;================================================================
    ;============ /Vertex Buffer layout 
    ;================================================================

;********************************************************************
;**************** /Equates
;********************************************************************



;********************************************************************
;**************** data
;********************************************************************
.data
    ;================================================================
    ;============ General Application Data
    ;================================================================
    hInstance           dd 0
    CommandLine         dd 0
    hCursor             dd 0
    hIcon               dd 0
    szClassName         db "_My_Class_Name_",0
    ;================================================================
    ;============ /General Application Data
    ;================================================================


    ;================================================================
    ;============ Specific Application Data
    ;================================================================
    fp1pt0              FLOAT 1.0f
    R                   FLOAT 57.3f
    angle1              dd 0
    scale1              FLOAT 1.0f
    scale2              FLOAT 1.0f
    bitmap              dw 04d42h
    bfsize              dd 0
                        dw 0,0
    bfoffbits           dd 0
                       
    ;================================================================
    ;============ /Specific Application Data
    ;================================================================


    ;================================================================
    ;============ DX9 Objects
    ;================================================================
    lpD3D               dd 0
    set lpD3D           as IDirect3D9
    lpd3dDevice         dd 0
    set lpd3dDevice     as IDirect3DDevice9
    lpVB                dd 0
    set lpVB            as IDirect3DVertexBuffer9
    lpTexture           dd 0
    set lpTexture   as IDirect3DTexture9

    pDefaultTexture     dd 0
    ;================================================================
    ;============ /DX9 Objects
    ;================================================================



    ;================================================================
    ;============ Other DX9-specific Data
    ;================================================================
    d3dpp               D3DPRESENT_PARAMETERS <NULL>
    
    vertices   CUSTOMVERTEX <20.0f , 20.0f, 50.0f, 1.0f,0.0f,0.0f>,\     
                            <640.0f , 20.0f , 50.0f,1.0f, 1.0f,0.0f>,\
                            <20.0f  , 500.0f , 50.0f,1.0f, 0.0f, 1.0f>,\
                            <640.0f,500.0f,50.0f,1.0f,1.0f,1.0f>
   vertices2   CUSTOMVERTEX <0.0f , 0.0f  , 1.0f,1.0f, 0.0f,0.0f>,\       
                            <640.0f , 0.0f , 1.0f,1.0f, 1.0f,0.0f>,\
                            <0.0f  , 500.0f , 1.0f,1.0f, 0.0f, 1.0f>,\
                            <640.0f,500.0f,1.0f,1.0f,1.0f,1.0f>
                            

                            FLOAT 3600 dup (1.0f)
    ;================================================================
    ;============ /Other DX9-specific Data
    ;================================================================

    

;********************************************************************
;**************** /data
;********************************************************************


;********************************************************************
;**************** code
;********************************************************************
.code



;********************************************************************
;**************** InitD3D
;********************************************************************
InitD3D PROC hWindow:DWORD
    LOCAL d3ddm:D3DDISPLAYMODE

    mov lpD3D, 0
    mov lpd3dDevice, 0
    mov lpVB, 0
    mov lpTexture, 0


    ;================================================================
    ;============ Create the D3D object
    ;================================================================       
    invoke Direct3DCreate9, D3D_SDK_VERSION
    mov lpD3D, eax   
    .if eax == NULL
        return E_FAIL
    .endif
    ;================================================================
    ;============ /Create the D3D object
    ;================================================================

    ;================================================================
    ;============ Get the current desktop display mode, so we can set
    ;============ up a backbuffer of the same format
    ;================================================================
    pcall lpD3D.GetAdapterDisplayMode,D3DADAPTER_DEFAULT,ADDR d3ddm
    .if eax !=D3D_OK
        return E_FAIL
    .endif
    ;================================================================
    ;============ /Get the current desktop display mode, so we can set
    ;============ up a backbuffer of the same format
    ;================================================================

    ;================================================================
    ;============ Set up the structure used to create the D3DDevice
    ;================================================================
    invoke RtlZeroMemory ,addr d3dpp,sizeof d3dpp
    mov d3dpp.Windowed, TRUE
    mov d3dpp.SwapEffect, D3DSWAPEFFECT_DISCARD
    mov eax, d3ddm.Format
    mov d3dpp.BackBufferFormat, eax
    ;mov d3dpp.EnableAutoDepthStencil ,TRUE;
    ;mov d3dpp.AutoDepthStencilFormat ,D3DFMT_D16
    ;================================================================
    ;============ /Set up the structure used to create the D3DDevice
    ;================================================================


    ;================================================================
    ;============ Create the D3DDevice, associated with the Window
    ;============ inwhich to Render
    ;================================================================
    mov lpd3dDevice,0
    pcall lpD3D.CreateDevice, D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWindow,\
                            D3DCREATE_SOFTWARE_VERTEXPROCESSING,\
                            ADDR d3dpp, ADDR lpd3dDevice
    .if eax !=D3D_OK
        .if eax==D3DERR_INVALIDCALL
            Message "Failed - InvalidCall"
        .elseif eax==D3DERR_NOTAVAILABLE
            Message "Failed - NotAvailable"
        .elseif eax==D3DERR_OUTOFVIDEOMEMORY
            Message "Failed - Out Of VideoMemory"
        .else
            Message "Failed - dunno why."
        .endif
        return E_FAIL
    .endif
    ;================================================================
    ;============ /Create the D3DDevice, associated with the Window
    ;============ inwhich to Render
    ;================================================================


    ;================================================================
    ;============ Global Device states would normally be set here
    ;================================================================


    pcall lpd3dDevice.SetTextureStageState, 0, D3DTSS_COLOROP, D3DTOP_SELECTARG1
    pcall lpd3dDevice.SetTextureStageState, 0, D3DTSS_COLORARG1, D3DTA_TEXTURE
    pcall lpd3dDevice.SetTextureStageState, 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE
    pcall lpd3dDevice.SetTextureStageState, 0, D3DTSS_ALPHAOP,   D3DTOP_DISABLE 

    pcall lpd3dDevice.SetRenderState, D3DRS_CULLMODE, D3DCULL_NONE
    pcall lpd3dDevice.SetRenderState,D3DRS_LIGHTING, FALSE
    pcall lpd3dDevice.SetRenderState,D3DRS_ZENABLE, TRUE




    ;================================================================
    ;============ /Global Device states would normally be set here
    ;================================================================


    return S_OK
InitD3D ENDP
;********************************************************************
;**************** /InitD3D
;********************************************************************


;********************************************************************
;**************** InitGeometry
;********************************************************************
InitGeometry proc
local pVertices:PTR
         invoke D3DXCreateTextureFromFile,   lpd3dDevice,        \
                                        CTEXT("water1024c.dds"), \ ;water1024c.dds
                                        addr lpTexture


    pcall lpd3dDevice.CreateVertexBuffer,   sizeof vertices,\
                                            0, D3DFVF_CUSTOMVERTEX,\
                                            D3DPOOL_DEFAULT, addr lpVB, NULL
    .if eax != D3D_OK
        Message "Error Creating vertex buffer"
        ret
    .endif

    pcall lpVB.Lock, 0, sizeof vertices, addr pVertices, 0
    .if eax!=D3D_OK
        Message "Error Locking vertex buffer"
        ret
    .endif
    invoke RtlMoveMemory, pVertices, offset vertices, sizeof vertices

    pcall lpVB.Unlock

    return D3D_OK
InitGeometry endp
;********************************************************************
;**************** /InitGeometry
;********************************************************************


;********************************************************************
;**************** Render
;********************************************************************
Render proc
    ;call InitGeometry

    ;================================================================
    ;============ Clear the backbuffer to a green colour
    ;================================================================
    pcall lpd3dDevice.Clear, 0, 0, (D3DCLEAR_TARGET OR D3DCLEAR_ZBUFFER), 00h, fp1pt0, 0 
    ;================================================================
    ;============ /Clear the backbuffer to a green colour ;8EC2ADh
    ;================================================================


    ;================================================================
    ;============ Begin the scene
    ;================================================================
    pcall lpd3dDevice.BeginScene
    .if eax == D3D_OK

;-------------------
        
        pcall lpd3dDevice.SetTexture, 0, lpTexture
        pcall lpd3dDevice.SetTextureStageState, 0, D3DTSS_COLOROP, D3DTOP_SELECTARG1
        pcall lpd3dDevice.SetTextureStageState, 0, D3DTSS_COLORARG1, D3DTA_TEXTURE
        pcall lpd3dDevice.SetTextureStageState, 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE
        pcall lpd3dDevice.SetTextureStageState,0,D3DTSS_ALPHAOP,   D3DTOP_DISABLE
        call SetupMatrices


        pcall lpd3dDevice.SetStreamSource, 0, lpVB, 0, sizeof(CUSTOMVERTEX)
        pcall lpd3dDevice.SetFVF, D3DFVF_CUSTOMVERTEX
        pcall lpd3dDevice.DrawPrimitive, D3DPT_TRIANGLELIST,0,1 ;D3DPT_TRIANGLESTRIP, 0,2 

;-------------------


        ;============================================================
        ;============ End the scene
        ;============================================================
        ; End the scene
        pcall lpd3dDevice.EndScene
        ;============================================================
        ;============ /End the scene
        ;============================================================
    .endif
    ;================================================================
    ;============ /Begin the scene
    ;================================================================


    ;================================================================
    ;============ Present the backbuffer contents to the display
    ;================================================================
    pcall lpd3dDevice.Present,0,0,0,0
    ;================================================================
    ;============ /Present the backbuffer contents to the display
    ;================================================================

    ret
Render endp
;********************************************************************
;**************** /Render
;********************************************************************

;********************************************************************
;**************** SetupMatrices
;********************************************************************
SetupMatrices PROC
LOCAL tmpmatrix:D3DMATRIX
LOCAL tmpmatrix2:D3DMATRIX
LOCAL matWorld:D3DMATRIX
LOCAL matView:D3DMATRIX
.DATA
    fpField_of_View     FLOAT 0.7853981635f
    fpAspect_Ratio      FLOAT 1.0f
    fpNear_Clipping_Plane   FLOAT 1.0f
    fpFar_Clipping_Plane    FLOAT 100.0f

    cam_vector      D3DXVECTOR3  <0.0f,0.0f,0.0f>
    lookat_vector   D3DXVECTOR3  <0.0f,0.0f,0.0f>
    world_UP_vector D3DXVECTOR3  <0.0f,1.0f,0.0f>
 .CODE
    
    invoke D3DXMatrixLookAtLH,addr matView,addr cam_vector,addr lookat_vector,addr world_UP_vector
    pcall lpd3dDevice.SetTransform,D3DTS_VIEW,addr matView



 invoke D3DXMatrixPerspectiveFovLH, addr matView,fpField_of_View,fpAspect_Ratio,\
                    fpNear_Clipping_Plane,fpFar_Clipping_Plane
                    pcall lpd3dDevice.SetTransform,D3DTS_PROJECTION,addr matView
                    pcall lpd3dDevice.SetTransform, D3DTS_TEXTURE0,addr matView
        pcall lpd3dDevice.SetTextureStageState, 0, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_COUNT2
        pcall lpd3dDevice.SetTextureStageState, 0, D3DTSS_TEXCOORDINDEX, D3DTSS_TCI_CAMERASPACEPOSITION 
    ret
SetupMatrices ENDP
;********************************************************************
;**************** /SetupMatrices
;********************************************************************                         

;********************************************************************
;**************** Cleanup
;********************************************************************
Cleanup PROC
    

    .if( lpTexture != NULL )        
        pcall lpTexture.Release
        mov lpTexture, 0
    .endif

    .if( lpVB != NULL )        
        pcall lpVB.Release
        mov lpVB, 0
    .endif

    .if( lpd3dDevice != NULL ) 
        pcall lpd3dDevice.Release
        mov lpd3dDevice, 0
    .endif

    .if( lpD3D != NULL )       
        pcall lpD3D.Release
        mov lpD3D, 0
    .endif

    ret
Cleanup ENDP
;********************************************************************
;**************** /Cleanup
;********************************************************************


;********************************************************************
;**************** RegisterWinClass
;********************************************************************
RegisterWinClass proc lpWndProc:DWORD, lpClassName:DWORD,
                      Icon:DWORD, Cursor:DWORD, bColor:DWORD
    LOCAL wc:WNDCLASSEX

    mov wc.cbSize,         sizeof WNDCLASSEX
    mov wc.style,          CS_BYTEALIGNCLIENT or \
                           CS_BYTEALIGNWINDOW
    m2m wc.lpfnWndProc,    lpWndProc
    mov wc.cbClsExtra,     NULL
    mov wc.cbWndExtra,     NULL
    m2m wc.hInstance,      hInstance
    m2m wc.hbrBackground,  bColor
    mov wc.lpszMenuName,   NULL
    m2m wc.lpszClassName,  lpClassName
    m2m wc.hIcon,          Icon
    m2m wc.hCursor,        Cursor
    m2m wc.hIconSm,        Icon

    invoke RegisterClassEx, ADDR wc
    ret
RegisterWinClass endp
;********************************************************************
;**************** /RegisterWinClass
;********************************************************************


;********************************************************************
;**************** WndProc
;********************************************************************
WndProc proc hWin   :DWORD,uMsg   :DWORD,wParam :DWORD,lParam :DWORD
    .if uMsg==WM_MOUSEMOVE
    mov eax,lParam
    mov ebx,eax
    and ebx,0ffffh
    sar eax,16
    mov [scale1],eax
    mov [scale2],ebx
    fild scale1
    fstp scale1
    fild scale2
    fstp scale2
    
    
    .endif
    .if uMsg==WM_DESTROY
        invoke Cleanup
        invoke PostQuitMessage,0
        return NULL
    .endif

    invoke DefWindowProc,hWin,uMsg,wParam,lParam

    ret
WndProc endp
;********************************************************************
;**************** /WndProc
;********************************************************************


;********************************************************************
;**************** WinMain
;********************************************************************
WinMain proc
local msg:MSG
local hWnd:DWORD

    invoke RegisterWinClass,ADDR WndProc,ADDR szClassName,
                       hIcon,hCursor,COLOR_BTNFACE+1
    invoke CreateWindowEx,WS_EX_LEFT,
                          ADDR szClassName,
                          CTEXT ("TESTBED"),
                          WS_OVERLAPPEDWINDOW,
                          0,0,800,600, ;CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
                          NULL,NULL,
                          hInstance,NULL
    mov hWnd,eax
    invoke ShowWindow,hWnd,SW_SHOW
    invoke UpdateWindow,hWnd

    invoke InitD3D, hWnd
    .if eax != S_OK
        Message "Failed to initiate D3D9 - Terminating"
        ret
    .else
        invoke InitGeometry
        .if eax != S_OK
            Message "Failed to initiate Geometry - Terminating"
            ret
        .else


            ;========================================================
            ;============ The MessagePump Loop
            ;========================================================
            ;The MessagePump Loop
            invoke RtlZeroMemory, addr msg,sizeof(MSG)
            .while( msg.message != WM_QUIT )
                invoke PeekMessage, addr msg, NULL, 0, 0, PM_REMOVE
                .if eax != 0
                    invoke TranslateMessage, addr msg
                    invoke DispatchMessage, addr msg
                .else
                    inc angle1
                    invoke Render
                .endif
            .endw
            ;========================================================
            ;============ /The MessagePump Loop
            ;========================================================

        .endif
    .endif


    mov eax, msg.wParam
    ret
WinMain endp
;********************************************************************
;**************** /WinMain
;********************************************************************


;********************************************************************
;**************** start
;********************************************************************

start:
      mov hInstance, $invoke (GetModuleHandle, NULL)
      mov CommandLine, $invoke (GetCommandLine)
      mov hCursor, $invoke (LoadCursor,NULL,IDC_ARROW)
      mov hIcon, $invoke (LoadImage,hInstance,500,IMAGE_ICON,32,32,0)    
      call WinMain
      invoke ExitProcess,0

end start
;********************************************************************
;**************** /start
;********************************************************************

;********************************************************************
;**************** /code
;********************************************************************
